What is XMLwriter?

XMLwriter is a professional validating XML editor for Windows.

XMLwriter validates XML documents against a DTD or Schema. The validating parser is 100% compatible with Microsoft's Internet Explorer 5, so you can confidently design your XML documents with the intent of viewing them successfully on the Web. XMLwriter performs batch validation, which automatically presents the results of the validation in the Error View.

XMLwriter has a text editing interface, with the aid and convenience of real-time colour syntax highlighting of tags and keywords. All HTML 4.0 tags and attributes, all CSS 2.0 properties, and all XSL, XSLT tags and formatting objects (fo) are recognised. XMLwriter supports all text file types, including XML, XSL, DTD, HTML and CSS.

TagBar is a special feature that has been included in XMLwriter that loads and displays all of the elements defined in a Schema document. Using TagBar, you can easily drag and drop elements quickly and accurately into an XML document.

XMLwriter supports stylesheet (XSL) conversion of XML documents. Converted files can be viewed in the Output View. Batch stylesheet conversion is also available.

XMLwriter has an internal browser view you can use to preview your documents. You can also view XML documents in Tree View, which shows the document's structure in an expandable element tree format.

XMLwriter has been designed with project management as a key focus. Project View has been specifically designed to create, edit and view files contained within a project. Project files are displayed in the Project View as an expandable file tree.

XMLwriter has a light-weight command line tool which allows you to perform XML validation and XSL conversion from the command line or a batch file.

XMLwriter is written entirely in C++, which makes it a fast and efficient editor compared to existing Java-based editors. It is a 32-bit program, aimed for systems running on Windows 95/98/2000 and Windows NT4. XMLwriter uses the Windows 95 interface guidelines, so users can expect a familiar and intuitive interface.

Enjoy!


Getting started

If you would like to get straight into creating XML documents, see the following help topics:

How to create a new file
How to validate an XML document
How to preview an file in the internal browser

If you are more interested in exploring XMLwriter’s functionality, open up the Examples project (Examples.xwp) which is installed as part of the example files. You can find it in the XMLwriter/Projects/Examples directory, in the directory where XMLwriter is installed. This project contains some example XML files, with DTDs, XSL stylesheets and Schema documents. See Examples.


XMLwriter's features

Choose the features you would like to read about the most:

XML-related features
User interface features
Functional features
Project management features

or just start scrolling...

XML-related features

  • Validates XML documents

    • XMLwriter validates XML documents against a DTD or Schema.

  • XML reference help guide

    • The XML reference (in program help) is a summary of the XML specification. It is aimed as a quick reference to XML syntax. It includes rules, examples and tips.

  • 100% IE5 compatibility

    • The validating parser used in XMLwriter is 100% percent compatible with Microsoft's IE5, so you can confidently design XML documents with the intent of viewing them successfully on the Web.

  • Stylesheet conversion

    • XMLwriter is capable of converting XML documents using XSL (stylesheets). Converted files are called "output files", and can be viewed in the Output View.

  • Performs batch validation and XSL (stylesheet) conversion

    • XMLwriter allows you to validate and convert multiple files simultaneously. The results of a batch validation are shown in the Error view. The results of a batch conversion are shown in the Output view.

  • Document templates for all supported file types

    • When you open a new file in XMLwriter, you can choose from a range of document templates. These templates have the basic set of markup required for each file type, and can be modified.

  • Tree view display of well-formed documents

    • XMLwriter allows you to view an XML document as an expandable element tree. Any well-formed XML document can be viewed in Tree View.

  • TagBar display of Schema components

    • TagBar allows you to load and display all of the elements defined in a Schema document. Using TagBar, you can drag and drop elements into an XML document.

  • Command line tool

    • XMLwriter has a light-weight command line tool which allows you to perform XML validation and XSL conversion from the command line or a batch file.

User interface features

  • Text editing user interface

    • XMLwriter has an easy to use, uncluttered, text editing interface. This means that you are not forced to enter your mark-up in a box here or a wizard there. You can directly edit text inside the document without having to wade through tedious interfaces.

  • Instant colour syntax highlighting

    • XMLwriter has real-time colour syntax highlighting, so you can easily distinguish between tags, attributes, comments and non-markup text. The syntax colouring feature recognises all HTML 4.0 tags and attributes, all CSS 2.0 properties, all XSL and XSLT tags and formatting objects (fo). Unknown tags or keywords are highlighted. All colours can be customised to your preferences.

  • Internal browser preview

    • You can see what your XML documents are going to look like on the Web by viewing them in the internal browser, which uses Microsoft's Internet Explorer 5.0 rendering engine.

  • Dockable toolbars and workspace windows

    • XMLwriter has dockable toolbar and workspace windows to allow you to easily manipulate the on-screen window environment. The toolbar and workspace windows can be toggled on or off, and documents can be edited at full-screen.

  • Multi-document user interface

    • View an unlimited number of documents simultaneously. The size of each document is limited only by your computer's available resources.

  • What's This? and online help

    • You will never be far from help in XMLwriter. XMLwriter comes with a comprehensive online help guide to take you through the "how to's". If you want a quick explanation of what something is, just click anywhere in the program window after activating the What's This? help button on the toolbar.

Functional features

  • Drag and Drop editing

    • Drag and drop editing is supported throughout XMLwriter. You can drag and drop files within Project View, drag files from Project View across to the document window, or drag and drop text within a document. You can also drag and drop elements from TagBar onto the document window.

  • Bookmarking capabilities

    • XMLwriter allows you to place bookmarks in a document for easy reference when editing large documents.

  • Find and Replace, Find Next.

    • XMLwriter allows you to search for strings of text in a file. The last few searches are stored in a drop-down list box on the tool bar, for easy reselection.

  • Unlimited Undo/Redo

    • XMLwriter allows unlimited undo and redo for quick and easy editing.

  • Auto-indent

    • Nesting tags is made easier with auto-indent. When you begin a new line, auto-indent positions your cursor at the same initial position of text on the previous line.

  • Print Preview

    • XML Writer allows you to preview your document and make any adjustments to the page margins and orientation.

  • Customisable toolbar, menus, and keyboard shortcuts

    • XMLwriter allows you to customise the existing toolbars, or create new ones. You can add your own custom icons, remove icons, or rearrange the existing icons. You can rearrange menu items, or you can change or add new keyboard shortcuts.

Project management features

  • Project View

    • Project View has been specifically designed to create, edit and view files contained within a project. Project files are displayed in the Project View as an expandable file tree.


"How To..." help topics

"How To..." contents page

  • Work with files
  • Work with projects
  • Work with documents
  • Work with TagBar
  • Work with Error View


"How to work with files" help topics

"How to work with files..." contents page

  • How to create a new file
  • How to preview a file in the internal browser
  • How to preview a file in an external browser
  • How to validate an XML document
  • How to convert an XML file using XSL
  • How to view an XML file in Tree View


How to create a new file

1 On the File menu, click New.
2 The New dialogue box is displayed.
3 If a project is open, un-check the Add to Project check box.
4 Double-click on the document template type you want to create.

Toolbar shortcut: New XML Document Click on the document icon to create a new XML document. Click on the arrow to select a document template.

Related Topics
The New File dialogue box explained
How to create a new file in a project
How to create a new project


How to preview a file in the internal browser

1 The file you wish to preview should be open in the active document window.
2 On the Tools menu, click Preview in Window.

To preview a file in the internal browser from Project View...

1 The project that contains the file you wish to preview should be open and visible in the Project View workspace.
2 Right-click on the filename in Project View.
3 Click on the Preview context menu item.

Tip: Use CTRL+TAB to toggle between document and preview windows.

Note: The Navigate menu and toolbar are displayed when viewing a document in the internal browser.

Related Topics
Recycle preview windows preference
How to preview a file in an external browser
How to view an XML file in Tree View
How to convert an XML file using XSL
How to validate an XML document


How to preview a file in an external browser

Specify your preferred browser in Preferences. The external browser preference is initially set to the windows default browser.

1 The file you wish to preview should be open in the active document window.
2 On the Tools menu, click Preview in Browser.

Tip: Use ALT+TAB to toggle between XMLwriter and external preview windows.

Related Topics
External browser preference
How to preview a file in the internal browser
How to view an XML file in Tree View
How to convert an XML file using XSL
How to validate an XML document


How to validate an XML document

1 The XML file you wish to validate should be open in the active document window.
2 On the Tools menu, click Validate XML File.
3 Check the status bar to see the validation result, or open Error View (Ctrl+Shift+2).

To validate an XML document from Project View...

1 The project that contains the XML file you wish to validate should be open and visible in the Project View workspace.
2 Right-click on the filename in Project View.
3 Click on the Validate context menu item.
4 Check the status bar to see the validation result, or open Error View (Ctrl+Shift+2).

Toolbar shortcut: Validate XML

Tip: To perform batch validation, you must have a project open. In the Project View, right-click on the project name and select Validate All XML Files.

Related Topics
How to perform batch validation
How to open a document from Error View
How to view an XML file in Tree View


How to convert an XML file using XSL

1 The file you wish to convert should have a valid XSL stylesheet.
2 Specify your preferred output (converted) file destination in Preferences.
3 On the Tools menu, click Convert using XSL.

Tip: To perform batch conversion, you must have a project open. In the Project View, right-click on the project name and select Convert All XML Files Using XSL. Select the Output tab to view the output files as an expandable file tree.

Note: When converting an XML file that does not belong to a project, remember to select your preferred output file destination in Preferences.

Related Topics
Output (converted) file preference
How to perform batch conversion


How to view an XML file in Tree View

How to view a file in Tree View

1 The file you wish to view as a tree should be open in the active document window.
2 On the Tools menu, click View As Tree.

To view a file in Tree View from Project View...

1 The project that contains the file you wish to view as a tree should be open and visible in the Project View workspace.
2 Right-click on the filename in Project View.
3 Click on the View As Tree context menu item.

Tip: In the Tree View window, click on the "-" or "+" to expand and contract the element tree. Use the keyboard shortcut CTRL+TAB to toggle between document and Tree View windows.

Related Topics
How to validate an XML document


"How to work with projects" help topics

"How to work with projects..." contents page

  • How to create a new project
  • How to open an existing project
  • How to close a project
  • How to save a project
  • How to create a new file in a project
  • How to create a new folder in a project
  • How to add existing files to a project
  • How to perform batch validation/conversion
  • How to rename a project, or files in a project
  • How to delete files in a project
  • How to drag and drop files in a project


How to create a new project

1 On the File menu, click New.
2 The New dialogue box is displayed.
3 Select the Projects tab.
4 Select the Project Name text box and enter a project name.
5 Click OK.
6 The Workspace is displayed with the Project View in focus. The project name is displayed at the root of the expandable file tree.

Tip: The project file extension ".xwp" is not required in the Project Name text box.

Note: By default, the project folder has the same name as the project file. The default location for new projects is the Projects Directory specified in Preferences. If you want to create a project in a different directory, click on the Browse for Folder button button next to the Location text box in the New dialogue box when creating a new project.

Related Topics
The New Project dialogue box explained
Default projects directory preference
How to create a new file in a project
How to create a new folder in a project
How to add existing files to a project


How to open an existing project

1 On the File menu, click Open Project.
2 The Open Project dialogue box is displayed.
3 In the Look in box select the drive or folder that contains the project.
4 Double-click the project file you want to open (project files have a ".xwp" file extension).
5 The Workspace is displayed with the Project View in focus. The project is displayed as an expandable file tree.

Toolbar shortcut: Open Project

Note: By default, the project folder has the same name as the project file.

Related Topics
How to create a new file in a project
How to create a new folder in a project
How to add existing files to a project
How to rename a project, or files in a project
How to delete files in a project
How to drag and drop files in a project


How to close a project

On the File menu, click Close Project.

Note: You will be prompted to close all the document windows. If you select yes, you will be prompted to save any modified documents.

Related Topics
How to save a project


How to save a project

On the File menu, click Save Project.

Note: Save Project is only available when the project has been modified.

Related Topics
How to rename a project, or files in a project
How to delete files in a project
How to drag and drop files in a project
How to close a project


How to create a new file in a project

1 The project you wish to add a new file to should be open and visible in the Project View workspace.
2 Right-click on the project name.
3 Click on the Add New File context menu item.
4 The New dialogue box is displayed.
5 Click on the document template you want to create.
6 Select the Filename text box and enter the filename (the file extension is not required).
7 Click OK.

Tip: To create a new file within a folder in a project, follow steps 3-7 above, after right-clicking on the folder name.

Related Topics
The New File dialogue box explained
How to create a new file (not in a project)
How to create a new folder in a project
How to add existing files in a project
How to rename files in a project
How to delete files in a project
How to drag and drop files in a project


How to create a new folder in a project

1 The project you wish to add a new folder to should be open and visible in the Project View workspace.
2 Right-click on the project name.
3 Click on the Add New Folder context menu item.
4 The New Folder dialogue box is displayed.
5 Enter a folder name.
6 Click OK.

Tip: To create a new folder within a folder in a project, follow steps 3-6 above, after right-clicking on the folder name.

Related Topics
How to create a new file in a project
How to add existing files to a project
How to rename folders in a project
How to delete folders in a project
How to drag and drop folders in a project


How to add existing files to a project

1 The project you wish to add a file to should be open and visible in the Project View workspace.
2 Right-click on the project name.
3 Click on the Add Files to Project context menu item.
4 The Add Files To Project dialogue box is displayed.
5 In the Look in box select the drive or folder that contains the file you want to add.
6 Double-click on the filename.

To add multiple files, follow steps 1 to 5, then, holding down the CTRL key, click on all the files you want to add. If you select a file you don't want, hold down the CTRL key and click the filename again to deselect it. To select adjacent files, hold down the SHIFT key instead of the CTRL key.

Tip: To add existing files to a folder, follow steps 4-6 above, after right-clicking on the folder name and selecting the Add Files to Folder context menu item.

Note: You can also add an existing Folder's contents by right-clicking on the project name, and selecting the Add Folder Contents context menu item.

Related Topics
How to create a new file in a project
How to create a new file (not in a project)
How to rename files in a project
How to delete files in a project
How to drag and drop files in a project


How to perform batch validation/conversion

Batch validation and conversion may only be performed on files that exist within a project.

1 The project you wish to validate or convert files in should be open and visible in the Project View workspace.
2 Right-click on the project name.
3 Click on the Validate All XML Files or Convert All XML Files Using XSL context menu item.
4 Check the Error View for the results of the batch validation, or select the Output tab to view the output files created from the batch conversion.

Tip: If you don't want to convert/validate every file in your project, you can convert/validate files in a sub-folder of the project by right-clicking on the folder name and following steps 3-4 above.

Note: You can also perform batch validation and conversion using XMLwriter's command line tool.

Related Topics
XMLwriter's command line tool
Default output directory preference
Default XSL output file extension preference
How to open a document from Error View
How to view an XML file in Tree View


How to rename a project

The project you wish to rename should be open and visible in the Project View workspace.

1 Right-click on the project name.
2 Click on the Rename context menu item.
3 Type in the new name of the project.
4 Press Enter.

Tip: You can also rename a project by clicking on the project name twice slowly, and typing in the new name.

Note: Renaming a project in the Project View does not rename the project on your hard disk. It is intended to be used as a descriptive name, and is displayed in the root of the Project View workspace.

To rename files or folders in a project...

Follow steps 2-4 above, after right-clicking on the filename or folder.

Tip: You can also rename files or folders, by clicking on the name twice slowly, and typing in the new name.

Note: Renaming files or folders is automatically reflected on your hard disk.

Related Topics
How to delete files in a project
How to drag and drop files in a project


How to delete files in a project

1 The project you wish to delete files in should be open and visible in the Project View workspace.
2 Right-click on the filename.
3 Click on the Delete context menu item.

To delete a folder in a project...

Follow the same method as above, after right-clicking on the folder name.

Note: When you delete a file or folder in a project, you will be prompted whether to delete the file or folder from your hard disk as well.

Related Topics
How to rename files in a project
How to drag and drop files in a project


How to drag and drop files in a project

1 The project you wish to move files in should be open and visible in the Project View workspace.
2 Select and drag the file you want to move.
3 To move the file to another folder, move the selection over the destination folder's name until it becomes highlighted, then release the mouse button.
4 To move the file to the root of the project, move the selection over the project's name until it becomes highlighted, then release the mouse button.

To drag and drop folders in a project...

Follow the same method as above, selecting and dragging the folder you want to move.

Tip: To copy a file/folder, hold down the CTRL key as you drag the file/folder.

Note: Rearranging files/folders in the Project View will automatically be reflected on your hard disk.

Related Topics
How to rename files in a project
How to delete files in a project


"How to work with documents" help topics

"How to work with documents..." contents page

  • How to find text
  • How to replace text
  • How to drag and drop text
  • How to indent lines
  • How to change font/font size
  • How to change the syntax colours
  • How to set a bookmark
  • Create a split view within a document


How to open a URL for editing

1 On the File menu, click Open URL.
2 The Open URL dialogue box is displayed.
3 Enter the URL you want to open in a document window.
4 Select the Bypass Cache/Proxy check box if you want to view the most recent copy of the URL.
5 Press OK.
6 If the URL is successfully located, it is displayed in a new document window, ready for editing.

Toolbar shortcut: Open URL

Related Topics
The Open URL dialogue box explained


How to find text in a document

1 On the Edit menu, click Find.
2 The Find dialogue box is displayed.
3 In the Find what text box, enter the text you want to search for.
4 Click Find Next.
5 To search for the next match press F3.

Toolbar shortcut: Enter the text you want to search for in the Find text box Find Text , then press Enter.

Tip: Press Esc to cancel Find.

Related Topics
How to replace text in a document


How to replace text in a document

1 On the Edit menu, click Replace.
2 The Replace dialogue box is displayed.
3 In the Find what text box, enter the text you want to search for.
4 In the Replace with text box, enter the replacement text.
5 Click Replace or Replace All.

Toolbar shortcut: Replace

Related Topics
How to find text
How to drag and drop text


How to drag and drop text in a document

1 Select the text you want to move.
2 Drag the selection to where you want to insert it.

Tip: To copy the selection, hold down the CTRL key as you drag the selection.

Related Topics
Default drag action preference
How to find text
How to replace text


How to indent lines in a document

1 Highlight the text you wish to indent (if the selection margin is switched on, click and scroll with the mouse pointer in the selection margin).
2 Press TAB as many times as you want to indent the selection.
3 Press ESC or click anywhere in the document window to deselect the selected text.

Tip: To unindent selections of text, follow the same procedure as above, pressing Shift+TAB.

Note: Auto indent is another feature of XMLwriter that allows you to begin the next line of text at the same initial position as the text on the previous line. The auto indent option can be selected in Preferences.

Related Topics
Selection margin preference
Auto indent preference
Tab size preference


How to change the editor font or font size

1 On the View menu, click Preferences.
2 The Preferences dialogue box is displayed.
3 Select the Format tab.
4 Under Editor Font, select the font from the Font drop down list box, and the font size from the Font Size drop down edit box.
5 Click OK.

Tip: You can also change the font size by selecting the Font Size drop down edit box, and manually entering a number.

Note: The fonts are a selection of fixed-width fonts. When you change the font or font size, all document windows are affected. You cannot change the font or font size of a selection of text.

Related Topics
How to change the syntax colours


How to change the syntax colours

1 On the View menu, select Preferences.
2 The Preferences dialogue box is displayed.
3 Select the Format tab.
4 Under Syntax Colours, select the syntax item you want to change from the Syntax Item drop down list box, and the colour you want to change it to from the Text Colour drop down palette.
5 Click OK.

Tip: If you select Automatic from the Text Colour drop down palette, the default colour for the selected syntax item will be used.

Note: You can create your own custom colours by clicking on the More Colours button at the bottom of the Text Colour drop down palette.

Related Topics
How to change font/font size


How to set a bookmark in a document

How to toggle a bookmark on and off in a document

1 Place your cursor anywhere on the line you want to bookmark (or remove a bookmark from).
2 Press Ctrl+F2.

Moving between bookmarks...

1 Press F2 to go to the next bookmark.
2 Press Shift+F2 to go to the previous bookmark.

Deleting all bookmarks...

Press Ctrl+Shift+F2.

How to toggle a numbered bookmark on and off in a document...

1 Place your cursor anywhere on the line you want to bookmark (or remove a bookmark from).
2 Press Ctrl+Num (where Num is any of the numeral keys along the top of the keyboard).

Moving between numbered bookmarks...

Press Alt+Num (where Num is the number of the bookmark you want to remove).

Note: All bookmarks are deleted when a document is closed.

Related Topics
Selection margin preference


How to create a split view within a document

1 On the Window menu, click Split.
2 Click anywhere within the document window to activate the split view.
3 To change the boundaries of the split view, hover over the split bar. When the pointer changes to a double arrow Split View , drag the split bar to the position you want.

Tip: To remove a split bar, double-click on it.

Note: You can move or copy text between parts of a lengthy document by splitting the window into two panes. Display the text you want to move or copy in one pane and the destination for the text in the other pane, and then select and drag the text across the split bar.

Related Topics
How to drag and drop text
Default drag action preference


"How to work with TagBar" help topics

"How to work with TagBar..." contents page

  • How to load a Schema into TagBar
  • How to add elements from TagBar to a document
  • How to hide and reveal tags in TagBar
  • How to insert content into elements in TagBar
  • TagBar explained


How to load a Schema document into TagBar

1 On the Tools menu, click Load TagBar.
2 The Load Schema into TagBar dialogue box is displayed.
3 In the Look in box, select the drive or folder that contains the Schema document you want to load.
4 Double-click the Schema document.
5 The Workspace is displayed with the TagBar View in focus. The Schema is displayed as an expandable element tree.

Note: The Schema documents loaded into TagBar must conform to IE5's support of the Schema language.

Related Topics
TagBar explained
How to add elements from TagBar to a document
How to hide and show tags in TagBar
How to insert content into elements in TagBar


TagBar explained

TagBar is a tool that lets you quickly compose an XML document based on an XML Schema. TagBar displays the Schema definition as an expandable element tree. This tree shows all the elements defined in the Schema, their relationships and attributes.

To get started with TagBar, use the Load TagBar command in the Tools menu to load a Schema document into TagBar. The root of the TagBar tree is the root element as defined in the loaded Schema. The children of an element in TagBar are the element’s attributes, the allowable child elements for that element, and any user defined content nodes.

(See also how to load a Schema into TagBar.)

Elements in TagBar

Each element represented in TagBar has an associated icon. The meanings of the icons are explained below:

sequence | A sequence of this element may appear. The order of the sequence matches the order shown in TagBar.
one | Only one of this element may appear.
many | Multiples (Many) of this element may appear in any order.

Additionally, the following icons represent attributes and content nodes:

attribute | An attribute of the parent element.
content node | A user defined content node.

Min, Max and Data Types

The minimum and maximum allowable number of each element is shown in the square [] brackets following the element name. The first number in the square brackets indicates the minimum allowable number of this element. The second number in the square brackets indicates the maximum allowable number of this element. An asterix (*) indicates that there is no limit on the maximum number of instances of the element.

The Schema datatypes as defined in the XML schema can also be displayed after the minimum and maximum values. The Show Datatypes in TagBar preference must be enabled to see datatypes. This preference is disabled by default.

Inserting Elements using TagBar

To insert an element into the current document using TagBar, click and drag the element you wish to insert. Drop the element in the location where you want to insert the element.

(See also how to add elements from TagBar to a document.)

TagBar Auto Insert

One of the most convenient features of TagBar is the ability to specify child elements, attributes and content that should be inserted when a given element is inserted.

The Auto Insert functionality is controlled at both a global and local level. There is a global preference called TagBar insert mode, which controls the overall behaviour of TagBar. This preference is accessible from the Preferences dialogue box, or by right clicking on a tree item in TagBar. The values that this preference may have are:

Don’t Insert Children | Only the specific element dragged from TagBar will be inserted. No attributes, child elements, or content nodes will be inserted.
Auto Insert Children | Only the attributes, child elements, and content nodes that are switched to Auto Insert will be inserted. See below for further explanation.
Insert All Children | All attributes, child elements, and content nodes will be inserted.

At a local level, you can individually specify which elements, attributes and content nodes should be automatically inserted. To switch an element on or off Auto Insert, right click on the element and select Auto Insert. Elements that are set for Auto Insert are displayed in bold in the TagBar tree.

(See also TagBar insert mode preference.)

Content Nodes

Content nodes allow you to define common or repeatedly used content for a particular element. To define a content node for an element or attribute, right-click on the tree item and select Add Content Node. After you type some text and press OK, a new child node will be created for the element or attribute you selected. If this content node is on Auto Insert, when you drag the parent element or attribute into the document the content will be placed inside the element’s start and end tags, or as the attribute value respectively.

You can define multiple content nodes for an element or attribute and include some or all of them by setting the Auto Insert properties of each.

You can also drag content nodes directly into the document, just inserting the text itself without an element or attribute.

(See also how to insert content into elements in TagBar.)

Hiding TagBar Items

If you are working with a very large Schema, it may be convenient to only display some portions of the Schema in TagBar. You can hide individual elements, attributes and content nodes in order to reduce clutter in TagBar. You hide a TagBar item by right clicking on the item and selecting Hide. You can show hidden items by clicking on the item’s parent and selecting the item from the Show Children list. Note that you cannot hide the root element.

Hidden items are still inserted if the global preference and the Auto Insert value for that item dictate that it should be inserted. This is convenient if you have a lot of standard elements that you still want to insert, but don’t need to see in TagBar.

(See also how to hide and show tags in TagBar.)

Additional Notes

When you load a schema, default values for attributes are automatically inserted as content nodes for that attribute. Attributes indicated as required in the Schema are initially set to Auto Insert.

You cannot save your changes to TagBar in this Beta version of XMLwriter. In the release version you will be able to save your content nodes and Auto Insert settings.


How to add elements from TagBar to a document

1 A Schema should be loaded and visible in the TagBar View workspace.
2 Expand the element tree of the Schema by clicking on the "+" symbols (or press "*" on the numeric keypad of your keyboard).
3 Click on the element you want to add to your document in TagBar View, and drag it to the position you want to insert it in the document.

Tip: To automatically add children elements when you drag a parent element across to a document, right-click on the child element(s) in TagBar View, and select the Auto Insert context menu item (the element font turns bold when Auto Insert is activated).

Note: You can choose TagBar's default insert mode for child elements from Preferences, or by right-clicking on the root element in TagBar.

Related Topics
TagBar insert mode preference
How to hide and show tags in TagBar
How to insert content into elements in TagBar


How to insert content into elements in TagBar

1 In TagBar View, right-click on the element you want to add content to.
2 Click on the Add Content context menu item.
3 The Create Content Node dialogue box is displayed.
4 Enter the content you want to add to the element.
5 Select the Set Auto-insert check box if you want the content to automatically be inserted when the element is dragged into the document.
6 Press OK.
7 The content is displayed in TagBar View (if Set Auto-insert was selected, the content will be bold in TagBar View).

Note: You can also add content to attributes, or add more than one content node to a tag. Content nodes may be dragged and dropped directly into the document.

Related Topics
TagBar insert mode preference
How to add elements from TagBar to a document
How to hide and show tags in TagBar


How to hide and show tags in TagBar

How to hide tags in TagBar

1 In TagBar View, right-click on the tag you want to hide.
2 Click on the Hide context menu item.

To show hidden tags in TagBar...

1 In TagBar View, right-click on the parent of the tag you want to show.
2 Under the Show Children context menu item, select the child element you want to show.

Note: Hiding children is merely a visual tool intended to unclutter the TagBar viewing environment. If Auto Insert is selected on any of the hidden children, those elements will still be added to the document when you drag and drop the parent element.

Related Topics
TagBar insert mode preference
How to add elements from TagBar to a document
How to insert content into elements in TagBar


"Error View" help topics

"Error View..." contents page

  • The Error View explained
  • How to open a document from Error View


Error View explained

The Error View explained

To view the Error View, on the View menu, click Error View, or on the toolbar, click Toggle Error View.

Click on the image map below to find out the explanation you are looking for.

Error Message File Validated Error In File Line Column
Error Message
This column displays the error message produced by Microsoft's IE5 XML parser. The icons give a quick visual representation of the validation result.

The XML document is not well formed.
The XML document is well formed, and has no declared DTD/Schema.
The XML document is well formed, and is valid according to the declared DTD/Schema.
The XML document is well formed, and is invalid according to the declared DTD/Schema.
File Validated
The validated file is displayed here.
Error in File
The file the error occurs in is displayed here.
Line
The line position of the error.
Column
The column position of the error.

Related Topics
How to open a document from Error View
Beep on validation errors preference
Jump to error after validation preference


How to open a document from Error View

Upon batch validation, the Error View will automatically appear with a list of all the files that were validated, or you can display Error View at any time by clicking on the toolbar button Toggle Error View.

1 In the Error View, double-click on the line of the error message you want to jump to.
2 If an error has occurred, the file the error occurred in is opened in a new document window, and the cursor is placed at the error position. If no error has occurred, the validated file is opened in a new document window.

Tip: As well as placing the cursor at the position of an error, XMLwriter displays error tabs in the selection margin. The selection margin must be turned on to view error tabs.

Related Topics
The Error View explained
Beep on validation errors preference
Jump to error after validation preference
Selection margin preference


Power users help topics

"Power Users..." contents page

  • How to use XMLwriter's command line tool
  • How to edit the default document type templates


How to edit the default document type templates

1 Open the document template you want to edit from the XMLwriter/Templates directory (template files have the file extension ".xwt").
2 Edit the document and save changes (to overwrite the template).

Note: You cannot create new document templates. You can only edit existing ones.


XMLwriter's command line tool help

The XMLwriter command line tool lets you perform validation and XSL conversion from the command line, batch files or anywhere else a command line can be configured.

Usage:

XMLwCmd.exe [-n] [-q] [-y] [-v] -i <xmlfile> [-s <xslfile>] [-o <outputfile>]

Options:
-n | No validation - Skips well-formdeness validation before XSL conversion.
-q | Quiet mode.
-y | Don't prompt when overwriting files.
-v | Validate input XML file against declared DTD or Schema instead of performing XSL conversion.
-i | Specifies the XML file to be validated or converted.
-s | Specifies the XSL stylesheet to be used in XSL conversion. This parameter is optional. If it is omitted, the input file name with an extension of .xsl will be assumed for the stylesheet.
-o | Specifies the name of the output file to create. If this parameter is omitted, the output filename will be the input filename with an .html extension.


User interface help topics

User Interface contents page

  • Windows
  • Menus
  • Toolbar
  • Keyboard shortcuts


Windows

XMLwriter's Windows

Click here to see a full-screen shot of the image below, or, click anywhere in the image below to find out more about each window.

Toolbar Workspace (includes Project View, TagBar, and Output View) Error View Status Bar Document Window Internal Preview Window

Workspace

The workspace window includes Project View, TagBar and Output View. These views are selected in the program by clicking on their respective tabs. The Workspace View can be toggled on or off, and is dockable.

To view the Workspace window: On the View menu, click Workspace.

Toolbar shortcut: Toggle Workspace icon
Project View
The Project View displays the currently open project as an expandable file tree. Drag and drop editing is supported within the Project View. Files can also be dragged and dropped onto the document window. Context menus are used extensively within Project View.

A full-screen shot of Project View

Related Topics:
How to create a new project
TagBar
TagBar displays all of the elements defined in a Schema document as an expandable element (or "tag") tree. Once a Schema is loaded into TagBar, you can toggle individual elements on and off, drag and drop selected elements into an XML document, and add contents to elements via context menus. Since TagBar is generated from a Schema, it allows you to maintain the validity of your XML document.

A full-screen shot of TagBar in action

Related Topics:
TagBar explained
Output View
Output files are created when XML files are converted using valid XSL stylesheets. The Output View displays the output files related to the project you have open as an expandable file tree. Right-clicking on a file in the Output View displays a context menu from which you can open a file for editing, or preview the file in the internal or external browser.

Related Topics:
How to convert an XML file using XSL
Document View
The Document View is the source text view of your documents. The document is edited directly in this window, and can be maximised or toggled to full-screen size.

Related Topics:
How to create a new file
Preview
The Preview is XMLwriter's internal browser. It displays a valid XML document as it would be seen on the Web.

Related Topics:
How to preview a file in the internal browser
Tree View
The Tree View displays well-formed XML documents as an expandable element tree. Even if your XML document does not have a DTD/Schema, you can still view the document in Tree View.

A full-screen shot of Tree View

Related Topics:
How to view an XML file in Tree View
Error View
The Error View is automatically displayed as a result of batch validation, or can be toggled on and off at any time. If a file displays an error message, double-clicking on the message in the Error View will open the file and place the cursor in the position where the error has occurred. The Error View is dockable.

To view Error View: On the View menu, click Errors.

Toolbar shortcut: Toggle Error View

Related Topics:
How to perform batch validation
Toolbar
The toolbar is completely customisable. It can be toggled on or off, and is dockable.

Related Topics:
How to add a button to a toolbar
Status bar
The status bar displays information about the current state of the document and application. Check the status bar for validation and conversion results.
Help
There are several forms of help in XMLwriter; What's This? help, program help, and XML reference help. What's This? help can be activated from the toolbar. Once activated, click anywhere within XMLwriter to find out the function of a screen component. You can also press F1 at any time for context-sensitive help. The program help provides "How to" directions and tips to help you use XMLwriter. The XML reference can be found within program help. It provides a summary of the fundamental rules and syntax of XML.

To view program help: On the Help menu, click Contents.

Toolbar shortcut: Help Contents icon


Default Menus

Default File Menu Description

New | Displays the New dialogue box, from which a new file or project can be created.
Open | Displays the Open dialogue box, from which existing files can be opened.
Open URL | Displays the Open URL dialogue box, in which a URL can be entered. If the URL is successfully located, the source text of that URL is opened in a new document window, ready for editing.
Close | Closes the active document without exiting the application. If the document contains any unsaved changes, you will be prompted to save the document before closing.
Open Project | Displays the Open Project dialogue box, from which existing projects can be opened.
Close Project | Closes the active project without exiting the application. If the project contains unsaved changes, you will be prompted to save the files before closing.
Save Project | Saves the active project with its current project name and location.
Save | Saves the active document with its current filename, location and file format. If it is a new document, the Save As dialogue box will be displayed.
Save As | Saves the active document with a different filename, location, or file format.
Save All | Saves all open documents with their current filenames, locations and file formats. If any of the open documents are new, the Save As dialogue box will be displayed.
Page Setup | Displays the Page Setup dialogue box, in which the paper size, paper source, page orientation, margins and printer properties for the active document can be set.
Print Preview | Displays each page of the active document as it will look when printed.
Print | Displays the Print dialogue box. Press Enter to print the active document or selection.
Send | Sends the active document as an attachment to a new mail message within your existing email software.
Recent Files | Displays a list of the most recently opened files.
Recent Projects | Displays a list of the most recently opened projects.
Exit | Closes XMLwriter after prompting you to save any modified documents.

Default Edit Menu Description

Undo | Reverses the last command or deletes the last entry you typed.
Redo | Reverses the action of the Undo command.
Cut | Removes the selection from the active document and places it on the clipboard.
Copy | Copies the selection to the clipboard.
Paste | Inserts the contents of the clipboard at the current cursor position, or replaces the selection.
Clear | Deletes the selected text.
Select All | Selects all of the text in the active document.
Find | Displays the Find dialogue box, in which a string of text can be entered. Press Enter to search the active document for the specified string.
Find Next | Finds, and highlights, the next occurrence of the last search string in the active document.
Replace | Displays the Replace dialogue box. The string you wish to replace in the active document should be entered into the "Find what:" text box, and the string you wish to replace it with should be entered into the "Replace with:" text box.
Bookmarks | Toggle Bookmark - Toggles a bookmark on the line where the cursor is placed in the active document. Go To Next - Moves the cursor to the line containing the next bookmark in the active document. Go To Previous - Moves the cursor to the line containing the previous bookmark in the active document. Clear All - Removes all bookmarks in the active document.
Go To | Moves the cursor to a specified line number.
Read Only | Toggles the active document to a read only status (RO is displayed in the status bar). A read only document cannot be modified.

Default View Menu Description

Toolbar | Toggles the toolbar on and off. The toolbar can be docked/undocked by clicking and dragging the grippers on the left side of the toolbar.
Status Bar | Toggles the status bar on and off.
Workspace | Toggles the workspace view on and off. The workspace view consists of the Project View, TagBar and Output View. Each view is activated by clicking on its respective tab. The workspace can be docked/undocked by clicking and dragging the grippers on the top of the workspace window.
Errors | Toggles the Error View on and off. The error view can be docked/undocked by clicking and dragging the grippers on the left side of the error view.
Full Screen | Toggles the full screen mode on and off. Hides the toolbar, title bar, menus and status bar so you can view more of your document.
Preferences | Displays the Preferences dialogue box, from which you can modify various program settings.
Customise | Displays the Customise dialogue box, from which you can customise toolbar buttons, menu commands, and shortcut keys.

Default Project Menu Description

Add New | Displays the New dialogue box, from which a new file can be created in the active project.
Add New Folder | Displays the New Folder dialogue box, in which a new folder name can be entered. Press Enter to create the new folder in the active project.
Add Files | Displays the Add File to Project dialogue box, from which one or more existing files can be added to the active project.
Add Folder Contents | Displays the Browse for Folder dialogue box, from which an existing folder can be selected, and added to the active project. When a folder is selected, all of its contents are included.
Validate All XML Files | Validates all the XML files in the active project.
Convert All XML Files Using XSL | Converts all XML files with valid XSL stylesheets in the active project.

Default Tools Menu Description

Preview in Window | Previews the active document in the internal browser.
Preview in Browser | Previews the active document in an external browser (as set in Preferences).
Validate XML File | Validates the active XML document.
Convert Using XSL | Converts the active XML document using the XSL stylesheet in the xsl-stylesheet declaration.
View As Tree | Previews the active document in the Tree View.
Load TagBar | Displays the Load Schema into TagBar dialogue box, from an existing Schema document can be selected.

Default Window Menu Description

New Window | Opens a new window view of the active document. This allows you to view different parts of a document at the same time.
Split | Splits the active window into panes, or allows you to relocate an existing split.
Close | Closes the active document. If the document contains any unsaved changes, you will be prompted to save the document before closing.
Close All Documents | Closes all document windows without exiting the application. If any of the documents contain any unsaved changes, you will be prompted to save those documents before closing.
Next | Activates the next window.
Previous | Activates the previous window.
Cascade | Arranges all the open windows so that they overlap.
Tile Horizontally | Arranges all the open windows as non-overlapping tiles, horizontally.
Tile Vertically | Arranges all the open windows as non-overlapping tiles, vertically.
Arrange Icons | Arranges minimised windows at the bottom of the window.
Windows | Opens the Windows dialogue box, in which open documents can be activated, saved, closed, cascaded, tiled or minimised.

Default Help Menu Description

Contents | Opens the contents page of XMLwriter's program help.
Search | Opens the search page of XMLwriter's program help.
Index | Opens the index page of XMLwriter's program help.
What's This? | Activates What's This? help. Click What's This?, then click anywhere in the program to display a pop-up window describing its function.
Registration | Displays the registration conditions, and instructions on how to register XMLwriter.
Technical Support | Displays the technical support form in XMLwriter's program help, which can be completed and sent to us directly via email.
XMLwriter On The Web | Has links to the XMLwriter website, including links to XMLwriter news, FAQs, support forms, and feedback forms.
About XMLwriter | Displays program information, version number and license agreement/copyright details.


Default toolbar

The Default Toolbar

New Document icon | New XML Document | Clicking on the document icon creates a new XML document. Clicking on the arrow displays a drop down menu from which you can create a new XML, XSL, DTD, HTML, CSS, or text document, based on their respective default templates. You can also create a new XMLwriter project from the drop down menu.
Open icon | Open File | Displays the Open dialogue box, from which existing files can be opened.
Open Project icon | Open Project | Displays the Open Project dialogue box, from which existing projects can be opened.
Open URL icon | Open URL | Displays the Open URL dialogue box, in which a URL can be entered. If the URL is successfully located, the source text of that URL is opened in a new document window, ready for editing.
Save icon | Save | Saves the active document with its current filename, location and file format. If it is a new document, the Save As dialogue box will be displayed.
Save All icon | Save All | Saves all open documents with their current filenames, locations and file formats. If any of the open documents are new, the Save As dialogue box will be displayed.
Cut icon | Cut | Removes the selection from the active document and places it on the clipboard.
Copy icon | Copy | Copies the selection to the clipboard.
Paste icon | Paste | Inserts the contents of the clipboard at the current cursor position, or replaces the selection.
Print icon | Print | Displays the Print dialogue box. Press Enter to print the active document or selection.
Undo icon | Undo | Reverses the last command or deletes the last entry you typed. Clicking on the arrow displays a drop down menu with the last ten user actions. All actions from startup can be reversed.
Redo icon | Redo | Reverses the action of the Undo command. Clicking on the arrow displays a drop down menu with the last ten reversed Undo actions. All Undo actions from startup can be reversed.
Toggle Workspace icon | Toggle Workspace | Toggles the Workspace View on and off.
Toggle Error View icon | Toggle Error View | Toggles the Error View on and off.
Find icon | Find | Displays the Find dialogue box, in which a string of text can be entered. Press Enter to search the active document for the specified string.
Find Text icon | Find Text | Allows you to enter a string of text. Press Enter to search the active document for the specified string. Clicking on the arrow displays a drop-down list box of recently entered strings of text. Selecting text from the drop-down list automatically executes a search.
Replace icon | Replace | Displays the Replace dialogue box. The string you wish to replace in the active document should be entered into the "Find what:" text box, and the string you wish to replace it with should be entered into the "Replace with:" text box.
Validate icon | Validate XML | Validates the active XML document.
What's This? icon | What's This? | Activates What's This? help. Click What's This?, then click anywhere in the program to display a pop-up window describing its function.
Help Contents icon | Help Topics | Displays the XMLwriter Help main window, with the table of contents in focus on the left.


Default Keyboard Shortcuts

Default Menu Shortcuts

Alt + F | File
Alt + E | Edit
Alt + V | View
Alt + P | Project
Alt + T | Tools
Alt + N | Navigate
Alt + W | Window
Alt + H | Help

Default File Menu Shortcuts

Ctrl + O | Open File
Ctrl + U | Open URL
Ctrl + F4 | Close File
Ctrl + S | Save
Ctrl + P | Print

Default Edit Menu Shortcuts

Ctrl + Z, Alt + Backspace | Undo
Ctrl + Y | Redo
Ctrl + X, Shift + Delete | Cut
Ctrl + C, Ctrl + Ins | Copy
Ctrl + V, Shift + Ins | Paste
Del | Clear
Ctrl + A | Select All
Ctrl + F | Find
F3 | Find Next
Ctrl + H | Replace
Ctrl + F2 | Toggle Bookmark
F2 | Go To Next Bookmark
Shift + F2 | Go To Previous Bookmark
Ctrl + Shift + F2 | Clear All Bookmarks
Ctrl + G | Go To

Default View Menu Shortcuts

Ctrl + Shift + 1 | Workspace
Ctrl + Shift + 2 | Error View
F12 | Full Screen

Default Tools Menu Shortcuts

F4 | Preview in Window
F5 | Preview in Browser
F6 | Validate XML File
F7 | Convert Using XSL
F8 | View As Tree
F9 | Load TagBar

Default Window Menu Shortcuts

Ctrl + Tab, Ctrl + F6 | Next Window
Ctrl + Shift + Tab, Shift + F6 | Previous Window

Default Help Menu Shortcuts

F1 | Help Contents
Shift + F1 | What's This?


Dialogue boxes help topics

"Dialogue Boxes explained..." contents page

  • New file
  • New project
  • Windows
  • Open URL
  • Go To
  • Customise Commands
  • Customise Toolbar
  • Customise Keyboard
  • Customise Button Appearance
  • Edit Button Image


The Customise Commands dialogue box explained

Click on the image map below to find out the explanation you are looking for.

Categories Commands Description
Categories
Displays the menu names. Select a menu name to view its commands in the Commands box.
Commands
Displays all of the commands and icons contained in the menu selected in the Categories box.
Description
Displays a description of the function of the selected command in the Commands box.

Related Topics
The Customise Toolbars dialogue box explained
The Customise Keyboard dialogue box explained
The Button Appearance dialogue box explained
The Edit Button Image dialogue box explained
How to add a command to a menu
How to add a button to a toolbar


The Customise Toolbars dialogue box explained

Click on the image map below to find out the explanation you are looking for.

Toolbars Show Tool Tips With Shortcut Keys Reset Reset All New Rename Delete
Toolbars
Displays a list of the available toolbars. Select a check box to display a toolbar. De-select a check box to hide a toolbar.
Show ToolTips
Select this check box to display tooltips when the mouse pointer is placed over a toolbar button. A tooltip is a description of the function of a toolbar button.
With Shortcut Keys
Select this check box to display the shortcut key associated with a tooltip, when the mouse pointer is placed over a toolbar button. The Show Tooltips check box must be selected for the With Shortcut Keys option to be enabled.
Reset
Restores the toolbar you have selected (highlighted) in the Toolbars box to its default settings.
Reset All
Restores all of the original toolbars listed in the Toolbars box to their default settings. Custom toolbars remain unchanged.
New
Displays the Toolbar Name dialogue box. Enter a name and click OK to create a new toolbar.
Rename
Displays the Toolbar Name dialogue box of the selected (highlighted) custom toolbar name in the Toolbars box. Enter a new name and click OK to rename an existing toolbar. Only custom toolbars can be renamed.
Delete
Deletes the selected (highlighted) toolbar name in the Toolbars box. Only custom toolbars can be deleted.

Related Topics
The Customise Commands dialogue box explained
The Customise Keyboard dialogue box explained
The Button Appearance dialogue box explained
The Edit Button Image dialogue box explained
How to show/hide a toolbar
How to create a new toolbar
How to rename a custom toolbar
How to delete a custom toolbar
How to show/hide tooltips on a toolbar
How to show/hide shortcut key assignments in tooltips
How to restore the original toolbar settings


The Customise Keyboard dialogue box explained

Click on the image map below to find out the explanation you are looking for.

Category Commands Current Keys Assign Remove Reset All Description Press New Shortcut Key
Category
Displays a drop down list box of all the menu names. Select a menu name to view its commands in the Commands box.
Commands
Displays all of the commands contained in the menu selected in the Categories box. Select a command to view its current shortcut key assignment in the Current Keys box.
Current Keys
Displays the current shortcut key assignment(s) for the command selected in the Commands box.
Press New Shortcut Key
To enter a new shortcut key, select this box, then press on the key you want to use as a shortcut key on the keyboard. If the key you press is already being used as a shortcut key in the program, "Assigned to: [a command]" will be displayed below the Press New Shortcut Key box, otherwise "Assigned to: [Unassigned]" will be displayed. Click the Assign button to add the new shortcut key to the Current Keys box. You can assign more than one shortcut key to a command.
Assign
Assigns the new shortcut key to the selected command in the Commands box. After pressing Assign, the new shortcut key will appear in the Current Keys box.
Remove
Removes the selected shortcut key in the Current Keys box.
Reset All
Restores XMLwriter's original shortcut key assignments.
Description
Displays a description of the function of the selected command in the Commands box.

Related Topics
The Customise Commands dialogue box explained
The Customise Toolbars dialogue box explained
The Button Appearance dialogue box explained
The Edit Button Image dialogue box explained
How to assign a new shortcut key to a command
How to remove a shortcut key from a command
How to restore the original shortcut key assignments


The Button Appearance dialogue box

Click on the image map below to find out the explanation you are looking for.

Image only Text only Image and text Use Default Image Select User-defined Image New Edit Button text OK Cancel Help
Image only
Select Image only to display the image of the currently selected button on the toolbar.
Text only
Select Text only to display the text of the currently selected button on the toolbar.
Image and text
Select Image and text to display the image and text of the currently selected button on the toolbar.
Use Default Image
Select Use Default Image to display the default image for the currently selected button on the toolbar.
Select User-defined Image
Allows you to select a new image for the currently selected button on the toolbar.
New
Displays the Edit Button Image dialogue box, in which a new icon can be created. This button is only available when Select User-defined Image is selected.
Edit
Displays the Edit Button Image dialogue box, in which the currently selected image in the Select User-defined Image box can be edited. This button is only available when Select User-defined Image is selected.
Button text
Displays the text that will be displayed on the toolbar if Text only is selected. Text in the Button text box can only be edited when Text only is selected.
OK
Applies the changes you have selected, and closes the Button Appearance dialogue box.
Cancel
Ignores the changes you have selected, and closes the Button Appearance dialogue box.
Help
Opens the help page you are looking at right now.

Related Topics
The Edit Button Image dialogue box explained
How to change a button's image


The Edit Button Image dialogue box

Click on the image map below to find out the explanation you are looking for.

Button Image Colours Tools Preview OK Cancel Help
Button Image
Displays a zoomed in view of the image you are creating/editing.
Preview
Displays the actual size of the image you are creating/editing.
Colours
Displays the color palette. To select a colour, click on it.
Tools
Displays the tools available for editing an image.
OK
Saves the new image you have created, and closes the Edit Button Image dialogue box. The new image can be viewed in the Select User-defined Image box.
Cancel
Ignores the new image you have created, and closes the Edit Button Image dialogue box.
Help
Opens the help page you are looking at right now.

Related Topics
How to change a button's image


Go To dialogue box explained

The Go To dialogue box explained

Click on the image map below to find out the explanation you are looking for.

Enter line number Go To Close
Enter line number
Enter the line number you want to go to in the active document.
Go To
Places the cursor at the line number you have entered.
Close
Closes the Go To dialogue box.

Related Topics
How to set a bookmark


New File dialogue box explained

The New File dialogue box explained

Click on the image map below to find out the explanation you are looking for.

File Types Add to Project Filename Location Browse for Folder
File Types
To create a new file, double-click on a document template. If you are creating a new file within a project you must enter the filename first.
Add to Project
Select this checkbox to add the new file to the currently open project.
Filename
Type a new name for the file. The file extension is not required.
Location
Shows your current folder location.
Browse for Folder
Click here to select a folder for the new file.

Related Topics
The New Project dialogue box explained
How to edit the default document type templates


New Project dialogue box explained

The New Project dialogue box explained

Click on the image map below to find out the explanation you are looking for.

Project types Project Name text box Location text box Location button
Project Types
To create a new project, double-click on a project type.
Project Name
Type a new name for the project. The file extension is not required.
Location
Shows the default folder location you have allocated for projects.
Choose Location
Click here to select a folder for the new project.

Related Topics
The New File dialogue box explained
Default project directory preference


Open URL dialogue box explained

Click on the image map below to find out the explanation you are looking for.

URL Bypass OK Cancel Help
URL
Enter the URL you want to retrieve a document from.
Bypass Cache/Proxy
Select this checkbox if you want to query the internet host directly for the URL (this ensures you download the most recent version of the URL).
OK
Attempts to find the URL you have entered. If successful, opens the source of the URL in a new document window, ready for editing.
Cancel
Closes the Open URL dialogue box.
Help
Opens the help page you are looking at right now.

Related Topics
How to open a URL for editing
How to preview a file in the internal browser
How to preview a file in an external browser


Windows dialogue box explained

The Windows dialogue box explained

Click on the image map below to find out the explanation you are looking for.

Select Window Activate OK Save Close Window(s) Cascade Tile Horizontally Tile Vertically Minimise Help
Select Window
Lists all of the currently open windows.
Activate
Activates the selected window in the Select Window list. You can also activate a window by double-clicking on its filename in the Select Window list.
OK
Closes the Windows dialogue box.
Save
Saves the selected file(s) in the Select Window list.
Close Window(s)
Closes the selected window(s) in the Select Window list.
Cascade
Cascades the selected windows in the Select Window list.
Tile Horizontally
Horizontally tiles the selected windows in the Select Window list.
Tile Vertically
Vertically tiles the selected windows in the Select Window list.
Minimise
Minimises the selected window(s) in the Select Window list.
Help
Opens the help page you are looking at right now.


Preferences

To view preferences, on the View menu, click Preferences.

The General Tab

Reload last project at startup | When enabled, reloads the last project you had open.
Reload documents when opening project | When enabled, opens all the documents you had open when you last worked on the project.
Automatically save project changes | When enabled, automatically saves any changes you make to the structure of a project (i.e. renaming folders/files, rearranging folders/files).
Ask for confirmation when deleting files | When enabled, asks for confirmation when deleting output files (in Output View).
Recycle preview windows | When enabled, previews documents in the same internal browser preview window. When disabled, multiple preview windows are created.
Beep on validation errors | When enabled, beeps when an error has been found in the file(s) you are validating.

The Editor Tab

Vertical scroll bar | When enabled, displays the vertical scroll bar on the right side of the document window.
Horizontal scroll bar | When enabled, displays the horizontal scroll bar at the bottom of the document window.
Selection Margin | When enabled, displays the selection margin on the left side of the document window.
Show whitespace | When enabled, displays whitespace between text as dots, and tabs as arrows.
Drag and drop text editing | When enabled, allows drag and drop text editing within the document window.
Default drag action is move | When enabled, the selection is moved when you drag it with the mouse. When disabled, the selection is copied when you drag it with the mouse. The Drag and drop text editing preference must be enabled for this preference to have an effect.
Tab size | Allows you to enter a tab size.
Auto indent | When enabled, starts the next line at the same initial position as the text on the previous line.

The Directories Tab

Projects directory | Lists the default hard disk location for your projects. Click Browse to set a new location.
Output directory | Lists the default hard disk location for your output files. Click Browse to set a new location.
Templates directory | Lists the default hard disk location for your document templates. Click Browse to set a new location.

The Tools Tab

Autosave before running tools | When enabled, saves the document you are validating before it is validated. Saves the document you are converting (with XSL) before it is converted. Saves the document you want to preview before it is previewed.
Jump to error on validation | When enabled, scrolls the document you are validating up to where the error has been found.
Default output file extension | Allows you to enter a default file extension for output files.
Converting a non-project file | Allows you to select the default action when performing XSL conversion on XML files that do not belong to a project. Creates a new document - opens the output file in a new document window. Shows internal preview - displays the output file in the internal browser preview window. Shows external preview - displays the output file in the external browser preview window. Shows Save As dialogue - displays the Save As dialogue box, from which you can choose a folder in which to save the output file.
External browser | Lists the hard disk location of your default browser. Click Browse to set a new default location.

The TagBar Tab

TagBar insert mode | Allows you to select the default insert-mode of child elements when inserting elements from TagBar into a document. Auto-insert children - inserts the child elements you have selected with Auto Insert via the context menu in TagBar, when you drag a parent element onto the document window. Don't insert children - does not insert any child elements when you drag a parent element onto the document window. Insert all children - inserts all child elements when you drag a parent element onto the document window.
Show data types in TagBar | When enabled, displays XML-Data datatypes as declared in the loaded Schema in TagBar.

The Format Tab

Font | Allows you to select a fixed-width font type.
Font size | Allows you to select, or enter a font size.
Syntax item | Allows you to select a syntax item to modify.
Text colour | Allows you to select a colour for the syntax item from the drop drown colour palette.
Sample text | Displays how text in the document will appear with the selected formatting preferences.


Customisable features help topics

"Customise Features..." contents page

  • Customisable menu help topics
  • Customisable toolbar help topics
  • Customisable shortcut key help topics


Customisable menu help topics

"How to customise menus..." contents page

  • How to add a command to a menu
  • How to delete a menu, or command from a menu
  • How to move a menu
  • How to restore original menu settings


How to add a command to a menu

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 In the Categories box, select All Commands.
4 Scroll through the Commands box, until you find the command you want to add.
5 Click on the command you want to add, and drag it over the menu you want to add it to in the main window (the menu will open).
6 Drag the command to where you want to place it in the menu, and release the mouse button.
7 Click Close on the Customise dialogue box to return to text editing mode.

Note: The black line that is displayed when you drag a command over the menu bar indicates where the command will be placed if you release the mouse button.

Related Topics
How to delete a menu, or command from a menu
How to move a menu
How to restore the original menu settings


How to delete a menu, or command from a menu

How to delete a menu

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 On the menu bar in the main window, right-click on the menu you want to delete.
4 Click on the Delete context menu item.
5 Click Close on the Customise dialogue box to return to text editing mode.

To delete a command from a menu...

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 On the menu bar in the main window, click on the menu you want to delete a command from.
4 Right-click on the command you want to delete.
5 Click on the Delete context menu item.
6 Click Close on the Customise dialogue box to return to text editing mode.

Related Topics
How to add command to a menu
How to move a menu
How to restore the original menu settings


How to move a menu

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 On the menu bar in the main window, click on the menu you want to move, and drag it to its new position.
4 Click Close on the Customise dialogue box to return to text editing mode.

Note: The black line that is displayed when you drag a menu indicates where the menu will be placed if you release the mouse button.

Related Topics
How to add command to a menu
How to delete a menu, or command from a menu
How to restore the original menu settings


How to restore original menu settings

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 In the Customise dialogue box, select the Toolbars tab.
4 In the Toolbars box, select the Menu Bar item so that it is highlighted.
5 Click Reset.
6 Click Close on the Customise dialogue box to return to text editing mode.

Related Topics
How to add command to a menu
How to delete a menu, or command from a menu
How to move a menu


Customisable toolbar help topics

"How to customise toolbars..." contents page

  • How to show/hide a toolbar
  • How to create a new toolbar
  • How to rename a custom toolbar
  • How to add a button to a toolbar
  • How to remove a button from a toolbar
  • How to display text, an icon, or both on a toolbar button
  • How to delete a custom toolbar
  • How to show/hide tooltips on a toolbar
  • How to show/hide shortcut key assignments in tooltips
  • How to dock/float a toolbar
  • How to edit a button image
  • How to restore original toolbar settings


How to show/hide a toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Toolbars tab.
4 In the Toolbars box, select the check box of the toolbar(s) you want to show, and de-select the check box of the toolbar(s) you want to hide.
5 Click Close on the Customise dialogue box to return to text editing mode.

Related Topics
How to create a new toolbar
How to add a button to a toolbar
How to remove a button from a toolbar
How to display text, an icon, or both on a toolbar button
How to dock/float a toolbar


How to create a new toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Toolbars tab.
4 Click New.
5 The Toolbar Name dialogue box is displayed.
6 Enter a name and press Enter.
7 The new toolbar name is displayed in the Toolbars box, and a new floating toolbar appears on the screen.
8 Select the Commands tab.
9 In the Categories box, select All Commands.
10 Click on the command you want to add, and drag it over the new toolbar.
11 Drag the command to where you want to place it on the toolbar, and release the mouse button.
12 Click Close on the Customise dialogue box to return to text editing mode.

Tip: To dock the new tool bar, drag it to any of the sides of the main window. A toolbar is docked when its gripper bars gripper bars appear. To undock a toolbar, click the grippers and drag the toolbar to its new position.

Note: The black line that is displayed when you drag a command over the toolbar indicates where the command will be placed if you release the mouse button.

Related Topics
How to dock/float a toolbar
How to add a button to a toolbar
How to remove a button from a toolbar
How to rename a custom toolbar
How to show/hide a toolbar
How to delete a custom toolbar


How to rename a custom toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Toolbars tab.
4 In the Toolbars box, select the toolbar you want to rename.
5 Click Rename.
6 The Toolbar Name dialogue box is displayed.
7 Enter the new name of the toolbar and press Enter.
8 The new toolbar name is displayed in the Toolbars box.
9 Click Close on the Customise dialogue box to return to text editing mode.

Note: Only custom toolbars can be renamed.

Related Topics
How to create a new toolbar
How to add a button to a toolbar
How to remove a button from a toolbar
How to delete a custom toolbar


How to add a button to a toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 In the Categories box, select All Commands.
4 Scroll through the Commands box, until you find the command you want to add.
5 Click on the command you want to add, and drag it over the toolbar.
6 Drag the command to where you want to place it on the toolbar, and release the mouse button.
7 Click Close on the Customise dialogue box to return to text editing mode.

Note: The black line that is displayed when you drag a command over the toolbar indicates where the command will be placed if you release the mouse button.

Related Topics
How to remove a button from a toolbar
How to display text, an icon, or both on a toolbar button
How to change a button's image


How to remove a button from a toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 On the toolbar in the main window, right-click on the button you want to remove.
4 Click on the Delete context menu item.
5 Click Close on the Customise dialogue box to return to text editing mode.

Related Topics
How to change a button's image
How to add a button to a toolbar
How to delete a custom toolbar


How to display text, an icon, or both on a toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 On the toolbar in the main window, right-click on the button you want to edit.
4 Click on the Button Appearance context menu item.
5 The Button Appearance dialogue box is displayed.
6 To display text, select Text only. To display an icon, select Image only. To display both, select Image and text.
7 Click Close on the Customise dialogue box to return to text editing mode.

Note: When Text Only is selected in the Button Appearance dialogue box, the Button text box becomes active. Enter your own text to display on the toolbar.

Related Topics
How to change a button's image
How to add a button to a toolbar
How to remove a button from a toolbar
How to show/hide tooltips on a toolbar
How to show/hide shortcut key assignments in tooltips


How to delete a custom toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Toolbars tab.
4 In the Toolbars box, select the custom toolbar you want to delete.
5 Click Delete.
6 Click Close on the Customise dialogue box to return to text editing mode.

Note: Only custom toolbars can be deleted.

Related Topics
How to show/hide a toolbar
How to create a new toolbar
How to rename a toolbar
How to restore the original toolbar settings


How to show/hide tooltips on a toolbar

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Toolbars tab.
4 Select the Show ToolTips check box to display tooltips on the toolbar. De-select this check box to hide tooltips on the toolbar.
5 Click Close on the Customise dialogue box to return to text editing mode.

Related Topics
How to display text, an icon, or both on a toolbar button
How to show/hide shortcut key assignments in tooltips


How to dock/float a toolbar

How to dock a floating toolbar

Click on the toolbar, and drag it to any side of the main window. The toolbar is docked when the gripper bars gripper bars appear on the toolbar.

To float a docked toolbar...

To float a docked toolbar, click on its gripper bars gripper bars, and drag the toolbar to its new floating position.

Note: The Menu Bar, Workspace, and Error View can also be docked/floated in XMLwriter.

Related Topics
How to show/hide a toolbar
How to delete a custom toolbar


How to change a button's image

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 On the toolbar in the main window, right-click on the image you want to change.
4 Click on the Button Appearance context menu item.
5 The Button Appearance dialogue box is displayed.
6 Select Select User-defined Image.
7 Click on a new image.
8 Click OK.
9 Click Close on the Customise dialogue box to return to text editing mode.

Tip: You can edit existing toolbar images by copying and pasting them into the Edit Button Image dialogue box.

Related Topics
How to add a button to a toolbar
How to remove a button from a toolbar
How to display text, an icon, or both on a toolbar button
How to restore the original toolbar settings


How to restore the original toolbar settings

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Toolbars tab.
4 Click Reset All.
5 Click Close on the Customise dialogue box to return to text editing mode.

Tip: To restore the settings of a single toolbar, select (highlight) the toolbar in the Toolbars box, then click Reset.


Customisable shortcut key help topics

"How to customise shortcut keys..." contents page

  • How to assign a new shortcut key to a command
  • How to remove a shortcut key from a command
  • How to restore original shortcut key assignments


How to assign a new shortcut key to a command

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Keyboard tab.
4 From the drop down list box under Categories, select All Commands (at the bottom).
5 In the Commands box, select the command you want to assign a new shortcut key to.
6 Select the Press New Shortcut Key box.
7 Press the key on the keyboard that you want to assign as the shortcut key.
8 Click Assign.
9 The new shortcut key appears in the Current Keys box.
10 Click Close on the Customise dialogue box to return to text editing mode.

Tip: You can assign as many shortcut keys as you want to a single command.

Note: When you choose a key in the Press New Shortcut Key box, text appears below the box, informing you whether that key is available, or whether it is already in use.

Related Topics
How to remove a shortcut key from a command
How to restore the original shortcut key assignments


How to remove a shortcut key from a command

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Keyboard tab.
4 From the drop down list box under Categories, select All Commands (at the bottom).
5 In the Commands box, select the command you want to remove a shortcut key from.
6 In the Current Keys box, select the shortcut key assignment you want to remove.
7 Click Remove.
8 Click Close on the Customise dialogue box to return to text editing mode.

Related Topics
How to assign a new shortcut key to a command
How to restore the original shortcut key assignments


How to restore the original shortcut key assignments

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Keyboard tab.
4 Click Reset All.
5 Click Close on the Customise dialogue box to return to text editing mode.


XML Reference Help Topics

The XML Reference

The XML Reference is a summary of the (W3C) XML Specification 1.0. Each section contains examples, rules to alert you of well-formedness and validity constraints, and notes that provide tips to help you understand XML syntax.

Graphics have been placed throughout the summary as a quick visual aid:
glossary | Click on this image to go to the glossary for an explanation about the word the image refers to.
well-formedness constraint | This image indicates a well-formedness constraint warning.
validity constraint | This image indicates a validity constraint warning.

XML Reference contents

  • XML declaration
  • Document type (DOCTYPE) declaration (includes DTDs)
  • ELEMENT declaration
  • Attribute-List declaration
  • Conditional sections
  • ENTITY declaration
  • NOTATION declaration
  • CDATA sections
  • Processing Instructions
  • Comments


XML declaration

The XML Declaration:

The XML declaration is a processing instruction that identifies the document as being XML. All XML documents should begin with an XML declaration.

<?xml version="version_number" encoding="encoding_declaration" standalone="standalone_status" ?>

Example:
<?xml version="1.0" encoding="UTF-8" standalone="no" ?>

Rules:
  • If the XML declaration is included, it must be situated at the first position of the first line in the XML document well-formedness constraint.
  • If the XML declaration is included, it must contain the version number attribute well-formedness constraint.
  • If all of the attributes glossary are declared in an XML declaration, they must be placed in the order shown above well-formedness constraint.
  • If any elements, attributes, or entities are used in the XML document that are referenced or defined in an external DTD, standalone="no" must be included validity constraint.
  • The XML declaration must be in lower case (except for the encoding declarations) well-formedness constraint.

Note:
  • The XML declaration has no closing tag, that is </?xml> well-formedness constraint.

The following table shows a list of the possible attributes that may be used in the XML declaration.

Attribute name: | Possible attribute value: | Attribute description:
version | 1.0 | Specifies the version of the XML standard that the XML document conforms to. The version attribute must be included if the XML declaration is declared well-formedness constraint .
encoding | UTF-8, UTF-16, ISO-10646-UCS-2, ISO-10646-UCS-4, ISO-8859-1 to ISO-8859-9, ISO-2022-JP, Shift_JIS, EUC-JP | These are the encoding names glossary of the most common character sets in use today. For a full list of encodings check the IANA's glossary website.
standalone | yes, no | Use 'yes' if the XML document has an internal DTD. Use 'no' if the XML document is linked to an external DTD, or any external entity references validity constraint .


document type declaration and DTDs

The document type declaration and DTDs:

The document type (DOCTYPE) declaration consists of an internal, or references an external Document Type Definition (DTD). It can also have a combination of both internal and external DTDs. The DTD defines the constraints on the structure of an XML document. It declares all of the document's element types glossary , children element types, and the order and number of each element type. It also declares any attributes, entities, notations, processing instructions, comments, and PE references in the document.

The internal DTD:

<!DOCTYPE root_element [

Document Type Definition (DTD):
elements/attributes/entities/notations/processing instructions/comments/PE references

]>

Example:
<?xml version="1.0" standalone="yes" ?>

<!--open the DOCTYPE declaration - the open square bracket indicates an internal DTD-->
<!DOCTYPE foo [

<!--define the internal DTD-->
    <!ELEMENT foo (#PCDATA)>

<!--close the DOCTYPE declaration-->
]>

<foo>Hello World.</foo>

Rules:
  • The document type declaration must be placed between the XML declaration and the first element (root element) in the document well-formedness constraint.
  • The keyword DOCTYPE must be followed by the name of the root element in the XML document validity constraint.
  • The keyword DOCTYPE must be in upper case well-formedness constraint.

The External DTD:

External DTDs are useful for creating a common DTD that can be shared between multiple documents. Any changes that are made to the external DTD automatically updates all the documents that reference it. There are two types of external DTDs: private, and public.

Rules:
  • If any elements, attributes, or entities are used in the XML document that are referenced or defined in an external DTD, standalone="no" must be included in the XML declaration validity constraint.

"Private" External DTDs:

Private external DTDs are identified by the keyword SYSTEM, and are intended for use by a single author or group of authors.

<!DOCTYPE root_element SYSTEM "DTD_location">

where:
  • DTD_location: relative or absolute URL glossary
Example:
<!--inform the XML processor that an external DTD is referenced-->
<?xml version="1.0" standalone="no" ?>

<!--define the location of the external DTD using a relative URL address-->
<!DOCTYPE document SYSTEM "subjects.dtd">

<document>
    <title>Subjects available in Mechanical Engineering.</title>
    <subjectID>2.303</subjectID>
        <subjectname>Fluid Mechanics</subjectname>
        <prerequisite>
            <subjectID>1.001</subjectID>
            <subjectname>Mathematics</subjectname>
        </prerequisite>
        <classes>4 hours per week (lectures and tutorials) for one semester.</classes>
        <assessment>tutorial assignments and one 2hr exam at end of course.</assessment>
        <syllabus>
        Fluid statics. The Bernoulli equation. Energy equation. Momentum
        equation. Differential Continuity equation. Differential Energy equation.
        Differential Momentum equation. Dimensional Analysis. Similitude. Laminar flow.
        Turbulent flow. Lift and Drag. Boundary layer theory.
        </syllabus>
        <textbooks>
            <author>Foobar</author>
            <booktitle>The Study of Fluid Mechanics</booktitle>
        </textbooks>
</document>

The external DTD ("subjects.dtd") referenced in the example above contains information about the XML document's structure:

subjects.dtd:
<!--see Element Type Declarations for an explanation of the following syntax-->
<!ELEMENT document (title*,subjectID,subjectname,prerequisite?,classes,assessment,syllabus,textbooks*)>
<!ELEMENT prerequisite (subjectID,subjectname)>
<!ELEMENT textbooks (author,booktitle)>
<!ELEMENT title (#PCDATA)>
<!ELEMENT subjectID (#PCDATA)>
<!ELEMENT subjectname (#PCDATA)>
<!ELEMENT classes (#PCDATA)>
<!ELEMENT assessment (#PCDATA)>
<!ATTLIST assessment assessment_type (exam | assignment) #IMPLIED>
<!ELEMENT syllabus (#PCDATA)>
<!ELEMENT author (#PCDATA)>
<!ELEMENT booktitle (#PCDATA)>

"Public" External DTDs:

Public external DTDs are identified by the keyword PUBLIC and are intended for broad use. The "DTD_location" is used to find the public DTD if it cannot be located by the "DTD_name".

<!DOCTYPE root_element PUBLIC "DTD_name" "DTD_location">

where:
  • DTD_location: relative or absolute URL glossary
  • DTD_name: follows the syntax:
"prefix//owner_of_the_DTD//description_of_the_DTD//ISO 639_language_identifier"

Example:
<?xml version="1.0" standalone="no" ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
"http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>A typical HTML file</TITLE>
</HEAD>
<BODY>
This is the typical structure of an HTML file. It follows the notation of the HTML 4.0
specification, including tags that have been deprecated (hence the "transitional" label).
</BODY>
</HTML>

Note:

The following prefixes are allowed in the DTD name:

Prefix: | Definition:
ISO | The DTD is an ISO standard. All ISO standards are approved.
+ | The DTD is an approved non-ISO standard.
- | The DTD is an unapproved non-ISO standard.

Combining Internal and External Document Type Definitions:

A document can use both internal and external DTD subsets. The internal DTD subset is specified between the square brackets of the DOCTYPE declaration. The declaration for the external DTD subset is placed before the square brackets immediately after the SYSTEM keyword.

Example:
<!--inform the XML processor that an external DTD is referenced-->
<?xml version="1.0" standalone="no" ?>

<!--define the location of the external DTD using a relative URL address -
the open square bracket indicates an internal DTD-->
<!DOCTYPE document SYSTEM "subjects.dtd" [

<!--the markup in the internal DTD takes precedence over the external DTD-->
    <!ATTLIST assessment assessment_type (exam | assignment | prac)>
    <!ELEMENT results (#PCDATA)>

<!--close the DOCTYPE declaration-->
]>

subjects.dtd:
<!ELEMENT document (title*,subjectID,subjectname,prerequisite?,classes,assessment,syllabus,textbooks*)>
<!ELEMENT prerequisite (subjectID,subjectname)>
<!ELEMENT textbooks (author,booktitle)>
<!ELEMENT title (#PCDATA)>
<!ELEMENT subjectID (#PCDATA)>
<!ELEMENT subjectname (#PCDATA)>
<!ELEMENT classes (#PCDATA)>
<!ELEMENT assessment (#PCDATA)>
<!ATTLIST assessment assessment_type (exam | assignment) #IMPLIED>
<!ELEMENT syllabus (#PCDATA)>
<!ELEMENT author (#PCDATA)>
<!ELEMENT booktitle (#PCDATA)>

Rules:
  • Declaring an ELEMENT with the same name in both the internal and external DTD subsets is invalid validity constraint.


ELEMENT declaration

The ELEMENT Type Declaration:

Element type declarations set the rules for the type and number of elements that may appear in an XML document, what elements may appear inside each other, and what order they must appear in.

<!ELEMENT name allowable_contents>

Example:
<!ELEMENT foo (#PCDATA)>
<!ELEMENT img EMPTY>

Rules:
  • All element types glossary used in an XML document must be declared in the Document Type Definition (DTD) using an Element Type Declaration validity constraint.
  • An element type cannot be declared more than once validity constraint.
  • The name in the element type's end tag glossary must match the name in the element type's start tag glossary well-formedness constraint. Element names are case sensitive.
  • The keyword ELEMENT must be in upper case well-formedness constraint.

Note:

The allowable contents of an element type is EMPTY, ANY, Mixed, or children element types.

Allowable Contents: | Definition:
EMPTY | Refers to tags that are empty. For example, the empty IMG tag from HTML may be represented in either of the following ways: <IMG SRC="grommit.gif"/>, or <IMG SRC="grommit.gif"></IMG> well-formedness constraint .
ANY | Refers to anything at all, as long as XML rules are followed. ANY is useful to use when you have yet to decide the allowable contents of the element.
children elements | You can place any number of element types within another element type. These are called children elements, and the elements they are placed in are called parent elements. See declaring children below.
Mixed content | Refers to a combination of (#PCDATA) and children elements. PCDATA stands for parsed character data, that is, text that is not markup. Therefore, an element that has the allowable content (#PCDATA) may not contain any children. See mixed content below.

Declaring children:

Children element types are declared using parentheses in the parent element type's declaration.

<!ELEMENT parent_name (child_name)>
<!ELEMENT child_name allowable_contents>

Example:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!--'student' must have one child element type 'id'-->
    <!ELEMENT student (id)>
    <!--'id' may only contain text that is not markup in its content-->
    <!ELEMENT id (#PCDATA)>
]>
<student>
    <id>9216735</id>
</student>

Rules:
  • The child element must be declared in a separate element type declaration validity constraint.

Declaring multiple children (sequence):

Multiple children are declared using commas (,). Commas fix the sequence in which the children are allowed to appear in the XML document.

<!ELEMENT parent_name (child1_name,child2_name,child3_name)>
<!ELEMENT child1_name allowable_contents>
<!ELEMENT child2_name allowable_contents>
<!ELEMENT child3_name allowable_contents>

Example:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!--'student' must contain three child elements in the order listed-->
    <!ELEMENT student (id,surname,firstname)>
    <!--the elements listed below may only contain text that is not markup-->
    <!ELEMENT id (#PCDATA)>
    <!ELEMENT firstname (#PCDATA)>
    <!ELEMENT surname (#PCDATA)>
]>
<student>
    <id>9216735</id>
    <surname>Smith</surname>
    <firstname>Jo</firstname>
</student>

Rules:
  • All of the children elements must be declared in a separate element type declaration validity constraint.

Declaring optional children:

Optional children are declared using the (?) operator. Optional means zero or one times.

<!ELEMENT parent_name (child_name?)>
<!ELEMENT child's_name allowable_contents>

Example:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!--'student' can have zero or one child element of type 'dob'-->
    <!ELEMENT student (dob?)>
    <!--'dob' may only contain text that is not markup in its content-->
    <!ELEMENT dob (#PCDATA)>
]>
<student>
    <dob>19.06.74</dob>
</student>

Rules:
  • If the child element is used in the XML document it must be declared in a separate element type declaration validity constraint.

Declaring zero or more children:

Zero or more children are declared using the (*) operator.

<!ELEMENT parent_name (child_name*)>
<!ELEMENT child_name allowable_contents>

Example:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!--'student' can have zero or more child elements of type 'subject'-->
    <!ELEMENT student (subject*)>
    <!--'subject' may only contain text that is not markup in its content-->
    <!ELEMENT subject (#PCDATA)>
]>
<student>
    <subject>Mathematics</subject>
    <subject>Physics</subject>
    <subject>Chemistry</subject>
</student>

Rules:
  • If the child element is used in the XML document it must be declared in a separate element type declaration validity constraint.

Declaring one or more children:

One or more children are declared using the (+) operator.

<!ELEMENT parent_name (child_name+)>
<!ELEMENT child_name allowable_contents>

Example:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!--'student' must have at least one child element of type 'subject'-->
    <!ELEMENT student (subject+)>
    <!--'subject' may only contain text that is not markup in its content-->
    <!ELEMENT subject (#PCDATA)>
]>
<student>
    <subject>Mathematics</subject>
</student>

Rules:
  • The child element must be declared in a separate element type declaration validity constraint.

Combinations of children (choice):

A choice between children element types is declared using the (|) operator.

<!ELEMENT parent_name (child1_name|child2_name)>
<!ELEMENT child1_name allowable_contents>
<!ELEMENT child2_name allowable_contents>

Example:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!--'student' must have 'id' or 'surname' as its child element-->
    <!ELEMENT student (id|surname)>
    <!--the elements listed below may only contain text that is not markup-->
    <!ELEMENT id (#PCDATA)>
]>
<student>
    <id>9216735</id>
</student>

Rules:
  • The child element used in the XML document must be declared in a separate element type declaration validity constraint.

Nesting ELEMENTs:

All of the following examples contain valid nested element declarations.

Examples:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!ELEMENT student (surname,firstname*,dob?,(origin|sex)?)>
    <!ELEMENT surname (#PCDATA)>
    <!ELEMENT firstname (#PCDATA)>
    <!ELEMENT sex (#PCDATA)>
]>
<student>
    <surname>Smith</surname>
    <firstname>Jo</firstname>
    <firstname>Sephine</firstname>
    <sex>female</sex>
</student>
<?xml version="1.0"?>
<!DOCTYPE student [
    <!ELEMENT student (surname,firstname)>
    <!ELEMENT firstname (fullname,nickname)>
    <!ELEMENT surname (#PCDATA)>
    <!ELEMENT fullname (#PCDATA)>
    <!ELEMENT nickname (#PCDATA)>
]>
<student>
    <surname>Smith</surname>
    <firstname>
        <fullname>Josephine</fullname>
        <nickname>Jo</nickname>
    </firstname>
</student>
<?xml version="1.0"?>
<!DOCTYPE student [
    <!ELEMENT student (sex|maritalstatus*)>
]>
<student>
</student>
<?xml version="1.0"?>
<!DOCTYPE student [
    <!ELEMENT student ((sex,maritalstatus)*)>
]>
<student>
</student>

Mixed content:

Mixed content is used to declare elements that contain a mixture of children elements and text (PCDATA glossary ).

<!ELEMENT parent_name (#PCDATA|child1_name)*>

Examples:
<?xml version="1.0"?>
<!DOCTYPE student [
    <!ELEMENT student (#PCDATA|id)*>
    <!ELEMENT id (#PCDATA)>
]>
<student>
    Here's a bit of text mixed up with the child element.
    <id>9216735</id>
    You can put text anywhere, before or after the child element.
    You don't even have to include the 'id' element.
</student>
<?xml version="1.0"?>
<!DOCTYPE student [
    <!ELEMENT student (#PCDATA)>
]>
<student>
</student>
<?xml version="1.0"?>
<!DOCTYPE student [
    <!ELEMENT student (#PCDATA|id|surname|dob)*>
    <!ELEMENT id (#PCDATA)>
    <!ELEMENT surname (#PCDATA)>
]>
<student>
    You can put text anywhere. You can also put the elements in any
    order in the document.
    <surname>Smith</surname>
    And, you don't have to include all the elements listed in the
    element declaration.
    <id>9216735</id>
</student>

Rules:
  • The same child element type glossary may only appear once in a mixed content declaration validity constraint.
  • If a child element is used in the XML document, it must be declared in a separate element type declaration validity constraint.
  • The (#PCDATA) and children element declarations must be separated by the (|) operator well-formedness constraint.
  • (#PCDATA) must come first in the mixed content declaration well-formedness constraint.
  • The operator (*) must follow the mixed content declaration if children elements are included well-formedness constraint.

Note:
  • Non-markup text (PCDATA) can be placed anywhere (before, between or after children elements).
  • The children elements can be placed in any order.


ATTLIST declaration

The Attribute-List (ATTLIST) Declaration:

Attributes are additional information associated with an element type glossary . They are intended for interpretation by an application. The ATTLIST declarations identify which element types may have attributes, what type of attributes they may be, and what the default value of the attributes are.

<!ATTLIST element_name attribute_name attribute_type default_value>
.
.
.
<element attribute_name="attribute_value">

where:
  • element_name: name of the element to which the attribute applies.
Example:
<?xml version="1.0"?>
<!DOCTYPE image [
    <!ELEMENT image EMPTY>
    <!ATTLIST image height CDATA #REQUIRED>
    <!ATTLIST image width CDATA #REQUIRED>
]>
<image height="32" width="32"/>

Rules:
  • All attributes used in an XML document must be declared in the Document Type Definition (DTD) using an Attribute-List Declaration validity constraint.
  • Attributes may only appear in start glossary or empty glossary tags well-formedness constraint.
  • The keyword ATTLIST must be in upper case well-formedness constraint.

Note:

There are three main attribute types; a string type, tokenized types, and enumerated types. They are classified as follows.

String attribute type: | Attribute description:
CDATA | CDATA stands for character data, that is, text that does not form markup. See example.

Tokenised attribute type: | Attribute description:
ID | ID is a unique identifier of the attribute. IDs of a particular value should not appear more than once in an XML document validity constraint . An element type may only have one ID attribute validity constraint . An ID attribute can only have an #IMPLIED or #REQUIRED default value validity constraint . The first character of an ID value must be a letter, '_', or ':' validity constraint . See example.
IDREF | IDREF is used to establish connections between elements. The IDREF value of the attribute must refer to an ID value declared elsewhere in the document validity constraint . The first character of an ID value must be a letter, '_', or ':' validity constraint . See example.
IDREFS | Allows multiple ID values separated by whitespace validity constraint .
ENTITY | ENTITYs are used to reference data that act as an abbreviation or can be found at an external location. The first character of an ENTITY value must be a letter, '_', or ':' validity constraint . See example.
ENTITIES | Allows multiple ENTITY names separated by whitespace validity constraint . See example.
NMTOKEN | The first character of an NMTOKEN value must be a letter, digit, '.', '-', '_', or ':' validity constraint . See example.
NMTOKENS | Allows multiple NMTOKEN names separated by whitespace validity constraint .

Enumerated attribute type: | Attribute description:
NOTATION | NOTATIONs are useful when text needs to be interpreted in a particular way, for example, by another application. The first character of a NOTATION name must be a letter, '_', or ':' validity constraint . See example.
Enumerated | Enumerated attribute types allow you to make a choice between different attribute values. The first character of an Enumerated value must be a letter, digit, '.', '-', '_', or ':' validity constraint . See example.

CDATA Example:
<?xml version="1.0"?>
<!DOCTYPE image [
    <!ELEMENT image EMPTY>
    <!ATTLIST image height CDATA #REQUIRED>
    <!ATTLIST image width CDATA #REQUIRED>
]>
<image height="32" width="32"/>
ID Example:
<?xml version="1.0"?>
<!DOCTYPE student_name [
    <!ELEMENT student_name (#PCDATA)>
    <!ATTLIST student_name student_no ID #REQUIRED>
]>
<student_name student_no="a9216735">Jo Smith</student_name>
IDREF Example:
<?xml version="1.0" standalone="yes"?>
<!DOCTYPE lab_group [
    <!ELEMENT lab_group (student_name)*>
    <!ELEMENT student_name (#PCDATA)>
    <!ATTLIST student_name student_no ID #REQUIRED>
    <!ATTLIST student_name tutor_1 IDREF #IMPLIED>
    <!ATTLIST student_name tutor_2 IDREF #IMPLIED>
]>
<lab_group>
    <student_name student_no="a8904885">Alex Foo</student_name>
    <student_name student_no="a9011133">Sarah Bar</student_name>
    <student_name student_no="a9216735"
    tutor_1="a9011133" tutor_2="a8904885">Jo Smith</student_name>
</lab_group>
ENTITY Example:
<?xml version="1.0" standalone="no"?>
<!DOCTYPE experiment_a [
    <!ELEMENT experiment_a (results)*>
    <!ELEMENT results EMPTY>
    <!ATTLIST results image ENTITY #REQUIRED>
    <!ENTITY a SYSTEM "http://www.university.com/results/experimenta/a.gif">
]>
<experiment_a>
    <results image="a"/>
<experiment_a>
ENTITIES Example:
<?xml version="1.0" standalone="no"?>
<!DOCTYPE experiment_a [
    <!ELEMENT experiment_a (results)*>
    <!ELEMENT results EMPTY>
    <!ATTLIST results images ENTITIES #REQUIRED>
    <!ENTITY a1 SYSTEM "http://www.university.com/results/experimenta/a1.gif">
    <!ENTITY a2 SYSTEM "http://www.university.com/results/experimenta/a2.gif">
    <!ENTITY a3 SYSTEM "http://www.university.com/results/experimenta/a3.gif">
]>
<experiment_a>
    <results images="a1 a2 a3"/>
</experiment_a>
NMTOKEN Example:
<?xml version="1.0"?>
<!DOCTYPE student_name [
    <!ELEMENT student_name (#PCDATA)>
    <!ATTLIST student_name student_no NMTOKEN #REQUIRED>
]>
<student_name student_no="9216735">Jo Smith</student_name>
NOTATION Example:
<?xml version="1.0"?>
<!DOCTYPE code [
    <!ELEMENT code (#PCDATA)>
    <!NOTATION vrml PUBLIC "VRML 1.0">
    <!ATTLIST code lang NOTATION (vrml) #REQUIRED>
]>
<code lang="vrml">Some VRML instructions</code>
Enumerated Example:
<?xml version="1.0"?>
<!DOCTYPE ToDoList [
    <!ELEMENT ToDoList (task)*>
    <!ELEMENT task (#PCDATA)>
    <!ATTLIST task status (important|normal) #REQUIRED>
]>
<ToDoList>
    <task status="important">This is an important task that must be completed</task>
    <task status="normal">This task can wait</task>
</ToDoList>

The "default_value" signifies whether an attribute is required or not, and if not, what default value should be displayed. The possible default values are listed in below.

Default value: | Description:
#REQUIRED | The attribute must always be included validity constraint .
#IMPLIED | The attribute does not have to be included.
#FIXED "Default_Value" | The attribute must always have the default value that is specified validity constraint . If the attribute is not physically added to the element tag in the XML document, the XML processor will behave as though the default value does exist. The first character of a default value can be any character except for '&', '<', '"'. It can also be an entity reference (i.e. '&Name;'), or a character reference validity constraint . See example.

Default Value Examples:
<?xml version="1.0"?>
<!DOCTYPE ToDoList [
    <!ELEMENT ToDoList (task)*>
    <!ELEMENT task (#PCDATA)>
    <!ATTLIST task status (important|normal) "normal">
]>
<ToDoList>
    <task status="important">This is an important task.</task>
    <task>This is by default a task that has a normal status.</task>
</ToDoList>
<?xml version="1.0"?>
<!DOCTYPE ToDoList [
    <!ELEMENT ToDoList (task)*>
    <!ELEMENT task (#PCDATA)>
    <!ATTLIST task status NMTOKEN #FIXED "monthly">
]>
<ToDoList>
    <task>go to the bank</task>
    <task>pay the phone bill</task>
</ToDoList>

Predefined attributes:

Predefined attributes: | Description:
xml:lang | Defines the language code in which the content of the element is written in. The attribute values of xml:lang should follow ISO-639 if they are two-letter codes, and ISO-3166 if they contain two-letter subcodes. Language identifiers registered with the IANA glossary should contain the prefix "I-" or "i-". Any privately used codes should contain the prefix "X-" or "x-".
xml:space | Preserves white space within a document, that is, passes all white space to the application unchanged. Useful when displaying text such as program source code.

Example:
<?xml version="1.0" standalone="yes"?>
<!DOCTYPE document [
    <!ELEMENT document (description,code)>
    <!ELEMENT description (#PCDATA)>
    <!ATTLIST description xml:lang NMTOKEN #FIXED "en">
    <!ELEMENT code (#PCDATA)>
    <!ATTLIST code xml:space (default|preserve) "preserve">
]>
<document>
    <description xml:lang="en">
    The following section of code diplays the menu of user
    choices and gets the user's request.
    </description>
    <code>
    do
      {
        do
         { disp_menu();
           scanf(" %d", &amp;ans);
         } while ((ans&lt;1) || (ans&gt;3));
    </code>
</document>


ENTITY declaration

The ENTITY Type Declaration:

Entities reference data that act as an abbreviation or can be found at an external location. Entities help to reduce the entry of repetitive information and also allow for easier editing (by reducing the number of occurrences of data to edit). There are two types of entity declarations: GENERAL entity declarations, and PARAMETER entity declarations.

The GENERAL ENTITY Declaration:

The types of general entities include:

  • INTERNAL (PARSED)
  • EXTERNAL (PARSED)
  • EXTERNAL (UNPARSED)

INTERNAL (PARSED) GENERAL ENTITY Declaration:

Internal parsed entities generally reference text. The correct definition is that they refer to data that an XML processor has to parse.

<!ENTITY name "entity_value">

where:
  • entity value: any character that is not an '&', '%' or ' " ', a parameter entity reference ('%Name;'), an entity reference ('&Name;') or a Unicode glossary character reference.
Example:
<?xml version="1.0" standalone="yes" ?>
<!DOCTYPE author [
    <!ELEMENT author (#PCDATA)>
    <!ENTITY js "Jo Smith">
]>
<author>&js;</author>

EXTERNAL (PARSED) GENERAL ENTITY Declaration:

External parsed entities generally reference text. The correct definition is that they refer to data that an XML processor has to parse. External entities are useful for creating a common reference that can be shared between multiple documents. Any changes that are made to external entities are automatically updated in the documents they are referenced. There are two types of external entities: private, and public. Private external entities are identified by the keyword SYSTEM, and are intended for use by a single author or group of authors. Public external entities are identified by the keyword PUBLIC and are intended for broad use.

<!ENTITY name SYSTEM "URI">
<!ENTITY name PUBLIC "public_ID" "URI">

where:
  • URI: In practice, this is a URL where the external parsed entity can be found.
  • public_ID: This may be used by an XML processor to generate an alternate URI where the external parsed entity can be found. If it cannot be found at this URI, the XML processor must use the normal URI.
Example:
<?xml version="1.0" standalone="no" ?>
<!DOCTYPE copyright [
    <!ELEMENT copyright (#PCDATA)>
    <!ENTITY c SYSTEM "http://www.xmlwriter.net/copyright.xml">
]>
<copyright>&c;</copyright>
<?xml version="1.0" standalone="no" ?>
<!DOCTYPE copyright [
    <!ELEMENT copyright (#PCDATA)>
    <!ENTITY c PUBLIC "-//W3C//TEXT copyright//EN" "http://www.w3.org/xmlspec/copyright.xml">
]>
<copyright>&c;</copyright>

EXTERNAL (UNPARSED) GENERAL ENTITY Declaration:

External unparsed entities generally reference non-XML data. The 100% correct definition is that they refer to data that an XML processor does not have to parse.

<!ENTITY name SYSTEM "URI" NDATA name>
<!ENTITY name PUBLIC "public_ID" "URI" NDATA name>

Example:
<?xml version="1.0" standalone="no" ?>
<!DOCTYPE img [
    <!ELEMENT img EMPTY>
    <!ATTLIST img src ENTITY #REQUIRED>
    <!ENTITY logo SYSTEM "http://www.xmlwriter.net/logo.gif" NDATA gif>
    <!NOTATION gif PUBLIC "gif viewer">
]>
<img src="logo"/>
<?xml version="1.0" standalone="no" ?>
<!DOCTYPE img [
    <!ELEMENT img EMPTY>
    <!ATTLIST img src ENTITY #REQUIRED>
    <!ENTITY logo PUBLIC  "-//W3C//GIF logo//EN" "http://www.w3.org/logo.gif" NDATA gif>
    <!NOTATION gif PUBLIC "gif viewer">
]>
<img src="logo"/>

Using entities within entities:

The following examples show how general entities can be used in the DTD.

CORRECT Example:
<?xml version="1.0"?>
<!DOCTYPE author [
    <!ELEMENT author (#PCDATA)>
    <!ENTITY email "josmith@theworldaccordingtojosmith.com">

    <!--the following use of a general entity is legal if it
    is used in the XML document-->
    <!ENTITY js "Jo Smith &email;">
]>
<author>&js;</author>

INCORRECT Example:
<!--the two entity statements are infinitely recursive-->
<!ENTITY email "user@user.com &js;">
<!ENTITY js "Jo Smith &email;">

Predefined GENERAL entities:

Predefined entities are entities already used for markup. The table below lists the predefined entities and how to declare them in a DTD.

Predefined entities: | How to declare these entities in a DTD:
&lt; | <!ENTITY lt "&#38;#60;">
&gt; | <!ENTITY gt "&#62;">
&amp; | <!ENTITY amp "&#38;#38;">
&apos; | <!ENTITY apos "&#39;">
&quot; | <!ENTITY quot "&#34;">

The PARAMETER ENTITY Declaration:

The types of parameter entities include:

  • INTERNAL (PARSED)
  • EXTERNAL (PARSED)

Rules:
  • Parameter entity references may not be used within markup in an internal DTD well-formedness constraint.

INTERNAL (PARSED) PARAMETER ENTITY Declaration:

Internal parameter entity references are used to declare entities existing only in the DTD.

<!ENTITY % name "entity_value">

where:
  • entity_value: any character that is not an '&', '%' or ' " ', a parameter entity reference ('%Name;'), an entity reference ('&Name;') or a Unicode glossary character reference.
Examples:
<!--external DTD example-->
<!ENTITY % p "(#PCDATA)">
<!ELEMENT student (id,surname,firstname,dob,(subject)*)>
<!ELEMENT id %p;>
<!ELEMENT surname %p;>
<!ELEMENT firstname %p;>
<!ELEMENT dob %p;>
<!ELEMENT subject %p;>
<!--external DTD example-->
<!ELEMENT author (#PCDATA)>
<!ENTITY % js "Jo Smith">

<!--note that the general entity statement below is used
to reference a parameter entity-->
<!ENTITY wb "written by %js;">
<!--external DTD example-->
<!ENTITY % info "(id,surname,firstname)">
<!ELEMENT lab_group_A %info;>
<!ELEMENT lab_group_B %info;>
<!ELEMENT lab_group_C %info;>

Note:
  • Note the use of external DTD examples above. Parameter entity references may not be used within markup in an internal DTD well-formedness constraint.

EXTERNAL (PARSED) PARAMETER ENTITY Declaration:

External parameter entity references are used to link external DTDs. There are two types of external entities: private, and public. Private external entities are identified by the keyword SYSTEM, and are intended for use by a single author or group of authors. Public external entities are identified by the keyword PUBLIC and are intended for broad use.

<!ENTITY % name SYSTEM "URI">
%name;
<!ENTITY % name PUBLIC "public_ID" "URI">
%name;

where:
  • URI: In practice, this is a URL where the external parameter entity can be found.
  • public_ID: This may be used by an XML processor to generate an alternate URI where the external parameter entity can be found. If it cannot be found at this URI, the XML processor must use the normal URI.
Example:
<?xml version="1.0" standalone="no"?>
<!DOCTYPE student [
    <!ENTITY % student SYSTEM "http://www.university.com/student.dtd">
    %student;
]>


NOTATION declaration

The NOTATION Declaration:

NOTATIONS are used to identify the format of unparsed entities (non-XML data), elements with a notation attribute, or specific processing instructions.

<!NOTATION name SYSTEM "URI">
<!NOTATION name PUBLIC "public_ID">
<!NOTATION name PUBLIC "public_ID" "URI">

where:
  • URI: In practice, this is a URL where the external notation can be found.
  • public_ID: This may be used by an XML processor to generate an alternate URI where the external notation can be found. If it cannot be found at this URI, the XML processor must use the normal URI.
Unparsed Entity Example:
<?xml version="1.0" standalone="no" ?>
<!DOCTYPE img [
    <!ELEMENT img EMPTY>
    <!ATTLIST img src ENTITY #REQUIRED>
    <!ENTITY logo SYSTEM "http://www.xmlwriter.net/logo.gif" NDATA gif>
    <!NOTATION gif PUBLIC "gif viewer">
]>
<img src="logo"/>
Notation Attribute Example:
<?xml version="1.0"?>
<!DOCTYPE code [
    <!ELEMENT code (#PCDATA)>
    <!NOTATION vrml PUBLIC "VRML 1.0">
    <!ATTLIST code lang NOTATION (vrml) #REQUIRED>
]>
<code lang="vrml">Some VRML instructions</code>


CDATA sections

CDATA sections are used to display markup without the XML processor trying to interpret that markup. They are particularly useful when you want to display sections of XML code.

<![CDATA[

any characters (including markup)

]]>

Example:
<?xml version="1.0"?>
<!DOCTYPE body [
    <!ELEMENT body (#PCDATA)>
]>

<body>

    <![CDATA[

    Here is an example of an internal DTD:
    <!DOCTYPE lab_group [
        <!ELEMENT lab_group (student_name)*>
        <!ELEMENT student_name (#PCDATA)>
        <!ATTLIST student_name student_no ID #REQUIRED>
        <!ATTLIST student_name tutor_1 IDREF #IMPLIED>
        <!ATTLIST student_name tutor_2 IDREF #IMPLIED>
    ]>

    ]]>

</body>

Rules:
  • the string ']]>' cannot be placed within a CDATA section, therefore, nested CDATA sections are not allowed well-formedness constraint.


Processing Instructions

Processing Instructions (PIs):

Processing instructions are used to embed information intended for proprietary applications. The XML declaration is an example of a processing instruction. Processing instructions beginning with 'xml' or 'XML' have been reserved for standardisation in the XML Version 1.0 specification and onwards.

<?PI-target ?>

where:
  • PI_target: any name that does not contain the letters 'X' or 'x', 'M' or 'm', or 'L' or 'l' in that order.
Example:
<?xml version='1.0'?>
<?word document="test.doc" ?>
<root>
</root>

Rules:
  • the string '?>' cannot be placed within a processing instruction, therefore, nested processing instructions are not allowed well-formedness constraint.


conditional sections

A way of including or excluding sections in the DTD is to use conditional sections. Conditional sections are of most use when linked to a parameter entity reference, and may only be used in an external DTD subset. The two conditional section statements are IGNORE and INCLUDE.

<![ IGNORE [

markup declarations

]]>

<![ INCLUDE [

markup declarations

]]>

Example:
<!ENTITY % draft "INCLUDE">
<!ENTITY % final "IGNORE">
<![%draft;[
<!ELEMENT book (title,author,summary)>
]]>
<![%final;[
<!ELEMENT book (comments*,title,author,summary)>
]]>
<!ELEMENT comments (#PCDATA)>
<!ELEMENT title (#PCDATA)>
<!ELEMENT author (#PCDATA)>
<!ELEMENT summary (#PCDATA)>

Rules:
  • Conditional sections may only be used in external DTD subsets well-formedness constraint.
  • Conditional sections must wrap around entire declarations well-formedness constraint.

Note:
  • The IGNORE declaration takes precedence over INCLUDE. If an IGNORE statement is nested inside an INCLUDE statement, the contents of the IGNORE statement will still be ignored.


comments

Comments are used to hide text from the end user when the output document is displayed. They are useful as notes to the author of the document, or other authors who may modify the document.

<!-- comments -->

Rules:
  • Comments may be placed anywhere after the XML declaration.
  • Comments may not be placed inside a tag glossary , but may be placed inside a document type declaration.
  • Double dashes '--' are not allowed inside a comment well-formedness constraint.
  • markup glossary may be used inside a comment.
  • Nested comments are not allowed.


Install Help

You can always find the latest version of XMLwriter at our website

There are two downloadable versions of XMLwriter, one for users with Internet Explorer 5.0 or higher installed, and one for users with Internet Explorer 4.01 SP1 or higher installed. Once you have downloaded the appropriate file, unzip it to a temporary folder and run setup.exe. Follow the on-screen prompts to install XMLwriter.

Related Topics
Remove Help


Remove Help

To remove XMLwriter, Open the Control Panel and double click Add/Remove Programs. Select XMLwriter 1.0 Beta and click Add/Remove.

Related Topics
Install Help


XML links on the Web

Recommended XML links on the Web

Introduction to XML
  • XML.com has a general introduction to XML that explains what XML is, how it compares to HTML, where it originated from, and the advantages of using it. It also has a technical introduction to XML which explains what XML documents look like, XML syntax, what DTDs are, and where and when you should use them. In the technical introduction you will also learn what a well-formed and valid XML document is, and a few extras like XLinks, XPointers, and Namespaces.

  • Project Cool has a quickstart guide to XML. The guide explains what XML is and what the advantages of using it are, compared to HTML. It also has examples of XML documents and where the language originated from.

  • Scientific American has a great feature article called XML and the Second-Generation Web, written by the authors and developers of the official W3C XML Specification. It explains, in great detail, the impact XML will have on the Internet.

  • The XML FAQ is a list of general, user, author, and developer questions and answers about XML.
Resources
  • The annotated XML specification, written by Tim Bray (co-author of the official W3C XML specification) takes you through the W3C XML specification with a lot of useful commentary. Tim gives you technical explanations, advice on how to use the spec, examples to illustrate the spec, and some amusing comments along the way.

  • The World Wide Web Consortium (W3C) is where all the official specs are developed, written and released. Check out the official Extensible Markup Language specification.

  • XML.com's XML Resource Guide will keep you busy for hours. It contains resources for various XML topics such as CSS, DTDs, Schemas, as well as the latest developments from the major XML players.

  • Microsoft's XML site

  • worldwideweave.com - an XML Web Directory and Search Engine

  • GoXml.com - another XML Web Directory and Search Engine
News
  • XML.com is an excellent place to go to keep up to date with the latest developments in the XML community.
XML related
  • XSL (Extensible Stylesheet Language) W3C Specification. The W3C is a good place to learn about style in general. Or you can go straight to their page on XSL. Have a look at Microsoft's XSL Developer's guide link to get a different angle on the topic.


Example files

We have included some example files in the XMLwriter/Projects/Examples directory to help you investigate XMLwriter's functionality.

The example files are in the example project Examples.xwp. If you are not sure how to open an existing project in XMLwriter, please see how to open an existing project.

  • In the Library directory of Examples.xwp:

    Library.xml can be previewed in the internal browser (see how to preview a file in the internal browser). Library.xml is an example of creating an XML document based on an XML Schema (LibrarySchema.xml). This example also illustrates XSL and has been formatted using the stylesheet Library.xsl.

    We have also included an example of how an XML document can be formatted using CSS. Take a look at LibraryCss.xml and Library.css. You can preview LibraryCss.xml in the internal browser.

    To explore TagBar's functionality, load LibrarySchema.xml into TagBar (see How to load a Schema into TagBar). You can create a new XML document (see How to create a new file), and drag and drop elements from TagBar into the new XML document (see how to add elements from TagBar to a document).

  • In the Passport directory of Examples.xwp we have included examples of internal and external DTD subsets.

If you want to learn more about the XML syntax have a look at our XML reference, or, go to our links page to find helpful XML-related web links.


Glossary

application

A self-contained program that performs a specific function directly for the user. An example of an application is XMLwriter. It is a standalone program that allows you to edit XML files as well as other text files.

attribute

Attributes are inserted in start or empty element tags in the form attribute_name="attribute_value". They are additional information about an element, intended for interpretation by an application. An example of an attribute is <img src="logo.gif"/>, where src is the attribute_name, and logo.gif is the attribute_value.

attribute-list (ATTLIST) declaration

Attribute-list declarations are placed inside a DTD. They specify what attributes are allowed in an XML document, to which element they belong, and what the default value of an attribute may be. An example of an ATTLIST declaration is <!ATTLIST img src EMPTY>.

browser

A program that allows you to interact with information stored in a variety of formats on the World Wide Web, private networks, or locally. Most browsers support a variety of information types including XML, HTML and Java. An example of a browser is Microsoft's Internet Explorer 5.

CDATA

Character data, or text that does not need to be parsed. Markup within CDATA sections will not be interpreted as markup.

character

In XML, a character is any legal graphic character of the ISO/IEC 10646 or Unicode standard (the two standards are identical). Other legal characters include a carriage return, tab and line feed.

child element

An element nested inside another (parent) element. For example:

<parent_element>
    <child_element>
    </child_element>
</parent_element>

CSS

Cascading Style Sheets. CSS are used to apply style (formatting) to HTML and XML documents.

document type (DOCTYPE) declaration

Used to contain an internal DTD, or point to an external DTD.

Document Type Definition

A set of rules describing the structure of an XML document. The document must conform to these rules in order to be valid.

DTD

See Document Type Definition.

empty tag

An element that has no content. In XML, an empty tag follows the syntax: <name></name> or <name/>.

end tag

The closing tag of an element. It follows the syntax: </name>, and must match the name in the start tag to be well-formed XML.

element type

The name that appears in a start, end or empty tag. In the following example there are three elements but only two element types:

<student>
    <firstname>Jo</firstname>
    <firstname>Sephine</firstname>
</student>

ELEMENT type declaration

Element type declarations are placed inside a DTD. They specify what elements are allowed in an XML document, and what their content may be. An example of an ELEMENT declaration is <!ELEMENT student (id,surname)>.

encoding names

Encoding Name | Character Set Description
UTF-8 | 8-bit Unicode transformation.
UTF-16 | 16,32-bit Unicode transformation.
ISO-10646-UCS-2 | 16 bit Unicode character set.
ISO-10646-UCS-4 | 32 bit Unicode character set.
ISO-8859-1 | Latin-1 (Latin America, Western Europe).
ISO-8859-2 | Latin-2 (Central and Eastern European).
ISO-8859-3 | Latin-3 (South-east Europe, miscellaneous).
ISO-8859-4 | Latin-4 (Scandanavia, Baltic).
ISO-8859-5 | Latin, Cyrillic.
ISO-8859-6 | Latin, Arabic.
ISO-8859-7 | Latin, Greek.
ISO-8859-8 | Latin, Hebrew.
ISO-8859-9 | Latin-5 (Latin, Turkish).
ISO-2022-JP | Japanese (multibyte).
Shift_JIS | Japanese, Windows (multibyte).
EUC-JP | Japanese, UNIX (multibyte).

ENTITY declaration

Entity declarations are placed inside a DTD. They contain the abbreviation to be used for an entity, and the text to be substituted for that abbreviation. They may also contain a URI if the text or data is stored at a remote location. An example of an ENTITY declaration is <!ENTITY js "Jo Smith">.

external DTD

A DTD that is contained in another file which may reside at a remote location.

general entity reference

An entity used in the content of an XML document. General entities follow the syntax '&name;'.

HTML

HyperText Markup Language. One of the publishing languages of the World Wide Web. HTML consists of a set of predefined tags that tell a browser how to display text and images to the end-user.

IANA

Internet Assigned Numbers Authority.

internal DTD

A DTD that is located within the XML document.

Java

A platform independent, object-oriented computer language, that has a similar syntactic structure to C++.

markup

Syntax used with text to indicate formatting instructions to a processor (or parser). In XML, the characters '<' and '&' signify the start of markup.

meta-data

A definition or description of a collection of data.

name

In XML, a name (e.g. an element, attribute, or an entity name) must begin with a letter, '_', or ':', and may continue with zero or more letters, digits, '.', '-', '_', or ':'.

NOTATION declaration

Notation declarations are placed inside a DTD. They are used to identify the format of non-XML data, and name (or point to) applications that will interpret the data. An example of a NOTATION declaration is <!NOTATION gif PUBLIC "gif viewer">.

parameter entity reference

An entity used within the DTD. Parameter entities follow the syntax '%name;'.

parent element

An element in which another (child) element is nested. For example:

<parent_element>
    <child_element>
    </child_element>
</parent_element>

parser

An application that processes a document and identifies text from markup. It interprets the markup and determines the content and characteristics of a document. An example of a parser is Microsoft's Internet Explorer 5 XML validating engine.

PCDATA

Parsed character data. Text that is not markup that is processed by a parser.

processing instruction

Used in an XML document to embed information intended for proprietary applications. An example of a processing instruction is <?word document="test.doc" ?>.

recursion

When something refers to itself.

root element

The first element in a document. It may not be contained by any other element in the document, hence, forms the basis of the document's element tree.

Schema document

An XML document which defines the structure and contents of other XML documents, in a similar manner to a DTD.

start tag

The opening tag of an element. It follows the syntax: <name>, and must match the name in the end tag to be well-formed XML.

tag

A start tag, end tag, or empty tag. A tag contains the name of an element.

Unicode

A system for the display, interchange, and processing of text written in any of a wide range of supported languages. The Unicode character set is a multi-byte character set that supports a wide range of international characters.

unparsed

Contains information that cannot be interpreted as text or markup.

URI

Uniform Resource Identifier. The generic set of all names or addresses that refer to resources.

URL

Uniform Resource Locator. They are URIs that locate and access resources specifically via the internet. URLs can be absolute (e.g. http://www.xmlwriter.net), or relative (e.g. doc001.xml).

validity constraint

Rules defined in the XML specification that are imposed on an XML document via the DTD. A document is valid if it conforms to the DTD and is well-formed.

W3C

World Wide Web Consortium. The W3C is responsible for releasing standards related to World Wide Web technology.

well-formedness constraint

Rules defined in the XML specification related to XML syntax. An XML document can exist merely as a well-formed document (i.e. not have any validity constraints).

XML

Extensible Markup Language. It is a subset of SGML (Standard Generalized Markup Language), using semantic tags in a structured format. XML is a flexible way to create information formats, and share both data and meta-data with other applications and users.

XML declaration

The processing instruction situated on the first line of an XML document. Every XML document should include an XML declaration. An example of an XML declaration is <?xml version="1.0" encoding="UTF-8" standalone="yes" ?>

XML specification

A recommendation released by the World Wide Web Consortium (W3C) on the 10th, February, 1998, as the official standard on how to write documents using XML. A complete listing of version 1.0 of the specification can be found at http://www.w3.org/TR/REC-xml.


Support

Note: You must have an active Internet connection for the following forms to work.

Please read our FAQs before completing any of the forms below, or join the XMLwriter-users mailing list from our mailing lists web page. If you can't find the answer there, choose which type of help you are looking for below:

XMLwriter technical support
You've found a bug
Website support
Sales/registration support
XMLwriter user comments and suggestions

If you are looking for our contact details click here.
XMLwriter technical support form
Items marked * must be completed.
Last Name: *
First Name: *
Registration No: (Registered users receive top priority)
Company:
Email: * Read here about our privacy policy
Processor:
Operating System:
RAM (MB):
Free Hard Disk Space (MB):
Web Browser: Other:
Your query:
Bug report form
Items marked * must be completed.
Last Name: *
First Name: *
Email: * Read here about our privacy policy
Processor:
Operating System:
RAM (MB):
Free Hard Disk Space (MB):
Web Browser: Other:
Bug description:
Steps required to reproduce problem:
Website support form
Items marked * must be completed.
Last Name: *
First Name: *
Email: * Read here about our privacy policy
Your query:
Sales/registration support form
Items marked * must be completed.
Last Name: *
First Name: *
Company:
Registration Name: (for users wishing to retrieve their registration number)
Email: * Read here about our privacy policy
Your query:


Tell us what you want/what you think

Tell us what you think

Note: You must have an active Internet connection for the following form to work.

Here is your opportunity to tell us what you think, and what you would like to see implemented in future releases of XMLwriter.
Items marked * must be completed.
Last Name: *
First Name: *
Email: * Read here about our privacy policy
Comments:
Your wish:


Registration Link

Register

Note: You must have an active Internet connection for the following link to work.

Please proceed to our website for registration details.


License agreement

Copyright

Copyright © 1999, Wattle Software: Chris Howard, Carmi Cronje.

XMLwriter and TagBar are trademarks of Wattle Software.

Portions Copyright 1999 Andrei Stcherbatchenko.

Portions Copyright 1999 Stas Levin.

Portions Copyright 1998-1999 Kirk Stowell.

Microsoft and Windows are registered trademarks of Microsoft Corporation.

Windows NT is a trademark of Microsoft Corporation.


License agreement

WATTLE SOFTWARE END-USER LICENSE AGREEMENT

XMLwriter 1.0 BETA
1. GENERAL

This End-User License Agreement ("EULA") is a legal agreement between you and Wattle Software for the Wattle Software products identified above, which may include computer software and associated media, electronic documentation and printed materials ("The Software"). By installing, copying, distributing or otherwise using The Software you agree to be bound by the terms of this EULA. If you do not agree to the terms of this EULA, you must not install, use or distribute The Software, and you must destroy all copies of The Software that you have. If The Software was purchased by you, and you have not installed, copied or otherwise used The Software, you may return it to Wattle Software for a full refund.

The Software is protected by copyright laws and international copyright treaties, as well as other intellectual property laws and treaties. The Software is licensed, not sold and always remains the property of Wattle Software.

2. LICENSING

If you have not paid the registration fee for The Software, you are hereby granted an evaluation license to use The Software as described in Sections 1, 2.1 and Sections 3 - 10 below.

If you have paid the registration fee for The Software, you are hereby granted a license to use The Software as described in Sections 1, 2.2 and Sections 3 - 10 below.

2.1. EVALUATION LICENSE
You may:

Subject to the terms of this EULA, use The Software for evaluation purposes without charge for a period of thirty (30) days only ("Evaluation Period"). The Evaluation Period commences when you first install or use The Software, and expires exactly thirty (30) days later.

You may not:

Use The Software after the Evaluation Period has expired without payment of the registration fee to Wattle Software.

Use of The Software after the Evaluation Period has expired requires payment of a registration fee of $US49 to Wattle Software. For more information about payment methods, please see ORDER.TXT, included with The Software.

Use of The Software after the Evaluation Period has expired is in violation of this EULA, and Australian and international copyright laws.

2.2. REGISTERED LICENSE
You may:

Subject to the terms of this EULA, use one copy of The Software on one computer. The primary user of the computer on which The Software is installed may make a second copy for his or her exclusive use on a portable computer.

You may also store or install a copy of The Software on a storage device, such as a network server, used only to install or run The Software on other computers over an internal network; however, you must acquire and dedicate a separate license for each separate computer on which The Software is installed or run from the storage device. A license for The Software may not be shared or used concurrently on different computers.

3. RESTRICTIONS

You may not reverse engineer, decompile, or disassemble The Software, except and only to the extent that such activity is expressly permitted by applicable law notwithstanding this limitation.

You may not rent, lease, or lend The Software except as described in Section 7 below.

4. TRANSFER OF RIGHTS

You may permanently transfer all of your rights under this EULA, provided you retain no copies of The Software, you transfer all of The Software (including all component parts, documentation upgrades, and this EULA), and the recipient agrees to the terms of this EULA. If The Software is an upgrade, any transfer must include all prior versions of The Software.

5. TERMINATION

Without prejudice to any other rights, Wattle Software may terminate this EULA if you fail to comply with the terms and conditions of this EULA. In such event, you must destroy all copies of The Software.

6. COPYRIGHT.

All title, including but not limited to copyrights, in and to The Software and any copies thereof are owned by Wattle Software. All title and intellectual property rights in and to the content which may be accessed through use of The Software is the property of the respective content owner and may be protected by applicable copyright or other intellectual property laws and treaties. This EULA grants you no rights to use such content. All rights not expressly granted are reserved by Wattle Software.

7. LIMITED WARRANTY

TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, WATTLE SOFTWARE DISCLAIMS ALL WARRANTIES AND CONDITIONS, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND NON-INFRINGEMENT, WITH REGARD TO THE SOFTWARE, AND THE PROVISION OF OR FAILURE TO PROVIDE SUPPORT SERVICES. WATTLE SOFTWARE DOES NOT WARRANT THAT THE SOFTWARE WILL MEET YOUR REQUIREMENTS OR THAT THE OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE.

8. LIMITATIONS OF REMEDIES AND LIABILITY

TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT SHALL WATTLE SOFTWARE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF PROFITS, BUSINESS INTERRUPTION, LOSS OF INFORMATION, OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE PRODUCT OR THE PROVISION OF OR FAILURE TO PROVIDE SUPPORT SERVICES, EVEN IF WATTLE SOFTWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN ANY CASE, WATTLE SOFTWARE'S ENTIRE LIABILITY UNDER ANY PROVISION OF THIS EULA SHALL BE LIMITED TO THE GREATER OF THE AMOUNT ACTUALLY PAID BY YOU FOR THE SOFTWARE PRODUCT OR $AUS 5.00. BECAUSE SOME STATES AND JURISDICTIONS DO NOT ALLOW THE EXCLUSION OR LIMITATION OF LIABILITY, THE ABOVE LIMITATION MAY NOT APPLY TO YOU.

9. DISTRIBUTION

You are hereby licensed to make as many copies of the installation package for The Software as you wish; give exact copies of the original installation package for The Software to anyone; and distribute the original installation package for The Software in its unmodified form via electronic or other means.

You are specifically prohibited from charging, or requesting donations, for any such copies, however made; and from distributing The Software including documentation with other products (commercial or otherwise) without prior written permission from Wattle Software. You are also prohibited from distributing components of The Software other than the complete original installation package.

10. JURISDICTION

This EULA shall be governed by the laws of New South Wales, Australia.


About us

Wattle Software is a dynamic software company specialising in cutting edge Internet applications. Established in 1998, Wattle Software aims to produce quality, user-friendly applications with comprehensive online help and support.

Our team of experienced professionals is always keen to hear feedback from our customers. Please let us know what you think of our latest creations at yoursay@XMLwriter.net

If you wish to contact us directly:

Email: | support@XMLwriter.net for technical support yoursay@XMLwriter.net to give us your feedback sales@XMLwriter.net for sales or registration enquiries exterminator@XMLwriter.net to send us bug reports webmaster@XMLwriter.net for web-related support
Send faxes to: | (419) 818-5533 (USA)
Send mail to: | Wattle Software PO Box 2, Northmead NSW 2152 Australia


XMLwriter help contents

 Welcome to XMLwriter (Beta) program help!

What is XMLwriter?

Features

XML-related features

User interface features

Functional features

Project management features

User interface

Windows

Menus

Toolbar

Keyboard shortcuts

Getting started...

How to...

Work with files

How to create a new file

How to preview a file in the internal browser

How to preview a file in an external browser

How to validate an XML document

How to convert an XML file using XSL

How to view an XML file in Tree View

Work with projects

How to create a new project

How to open an existing project

How to close a project

How to save a project

How to create a new file in a project

How to create a new folder in a project

How to add existing files to a project

How to perform batch validation/conversion

How to rename a project, or files in a project

How to delete files in a project

How to drag and drop files in a project

Work with documents

How to find text

How to replace text

How to drag and drop text

How to indent lines

How to change font/font size

How to change the syntax colours

How to set a bookmark

Create a split view within a document

Work with TagBar

How to load a Schema into TagBar

How to add elements from TagBar to a document

How to hide and show tags in TagBar

How to insert content into elements in TagBar

TagBar explained

Work with Error View

The Error View explained

How to open a document from Error View

How to open a URL for editing

How to (for power users)...

How to use XMLwriter's command line tool

How to edit the default document type templates

Installation

Install XMLwriter

Remove XMLwriter

Preferences

Customisable features

How to customise menu settings

How to add a command to a menu

How to delete a menu, or command from a menu

How to move a menu

How to restore the original menu settings

How to customise toolbar settings

How to show/hide a toolbar

How to create a new toolbar

How to rename a custom toolbar

How to add a button to a toolbar

How to remove a button from a toolbar

How to display text, an icon, or both on a toolbar button

How to delete a custom toolbar

How to show/hide tooltips on a toolbar

How to show/hide shortcut key assignments in tooltips

How to dock/float a toolbar

How to change a button's image

How to restore the original toolbar settings

How to customise shortcut key assignments

How to assign a new shortcut key to a command

How to remove a shortcut key from a command

How to restore the original shortcut key assignments

Dialogue boxes explained

New file

New project

Windows

Open URL

Go To

Customise Commands

Customise Toolbar

Customise Keyboard

Button Appearance

Edit Button Image

Example files

Reference Help

The XML Reference

The XML Declaration

The DOCTYPE Declaration (and DTDs)

ELEMENT Type Declarations

Attribute-List Declarations

Conditional Sections

ENTITY Declarations

NOTATION Declarations

CDATA Sections

Processing Instructions

Comments

Helpful links on the Internet

Glossary

Support

Tell us what you want/what you think

Register

About us

Wattle Software End-User License Agreement

Copyright


.topic 1018
When enabled, reloads the last project you had open.
.topic 1019
When enabled, opens all the documents you had open when you last worked on the project.
.topic 1020
When enabled, automatically saves any changes you make to the structure of a project (i.e. renaming folders/files, rearranging folders/files).
.topic 1023
When enabled, asks for confirmation when deleting output files (in Output View).
.topic 1045
When enabled, previews documents in the same internal browser preview window. When disabled, multiple preview windows are created.
.topic 1038
When enabled, beeps when an error has been found in the file(s) you are validating.
.topic 1037
Lists the default hard disk location for your output files. Click Browse to set a new location.
.topic 1033
Lists the default hard disk location for your projects. Click Browse to set a new location.
.topic 1039
Lists the default hard disk location for your document templates. Click Browse to set a new location.
.topic 1022
When enabled, displays the vertical scroll bar on the right side of the document window.
.topic 1024
When enabled, allows drag and drop text editing within the document window.
.topic 1025
When enabled, displays the horizontal scroll bar at the bottom of the document window.
.topic 1026
When enabled, displays the selection margin on the left side of the document window.
.topic 1027
When enabled, starts the next line at the same initial position as the text on the previous line.
.topic 1028
Allows you to enter a tab size.
.topic 1029
When enabled, the selection is moved when you drag it with the mouse. When disabled, the selection is copied when you drag it with the mouse. The Drag and drop text editing preference must be enabled for this preference to have an effect.
.topic 1046
When enabled, displays whitespace between text as dots, and tabs as arrows.
.topic 1034
Saves the document you are validating before it is validated. Saves the document you are converting (with XSL) before it is converted. Saves the document you want to preview before it is previewed.
.topic 1040
Scrolls the document you are validating up to where the error has been found.
.topic 1078
Allows you to select the default action when performing XSL conversion on XML files that do not belong to a project.

Creates a new document - opens the output file in a new document window.

Shows internal preview - displays the output file in the internal browser preview window.

Shows external preview - displays the output file in the external browser preview window.

Shows Save As dialogue - displays the Save As dialogue box, from which you can choose a folder in which to save the output file.
.topic 1042
Lists the hard disk location of your default browser. Click Browse to set a new default location.
.topic 1044
Displays the Internet Control Panel applet. You can change your proxy and other Internet settings.
.topic 1054
Allows you to select a fixed-width font type.
.topic 1062
Allows you to select, or enter a font size.
.topic 1058
Allows you to select a colour for the syntax item from the drop drown colour palette.
.topic 1066
Displays how text in the document will appear with the selected formatting preferences.
.topic 1050
Allows you to select a syntax item to modify.
.topic 1068

.topic 1077
When enabled, shows XML-Data datatypes in TagBar view if the Schema has declared datatypes.


FAQs

 As XMLwriter has just been released, we have anticipated a few questions you may ask. This list will be updated on a regular basis as you send us more questions.
Does XMLwriter support Unicode?
Unicode will be supported in a future Windows NT version.
Can XMLwriter be used for HTML editing?
Yes. XMLwriter supports HTML and CSS files. If you are using XMLwriter to write HTML documents, you can still take advantage of features such as the Project View to manage your files. You can also preview your files in the internal browser.
What type of files can I edit in XMLwriter?
Any text file can be edited in XMLwriter. Most importantly, XML, XSL, DTD, HTML and CSS files can be edited in XMLwriter. The real time colour syntax highlighting of tags works with all of the listed file types. For example, in HTML documents, any tag that is not defined in the W3C's HTML 4.0 Specification will be highlighted.
Can I use XMLwriter on Windows 3.X, Macintosh or Unix?
No. XMLwriter is designed for the Windows 95/98/2000 and Windows NT4 operating systems.
Do I need to have a particular browser installed to use XMLwriter?
Yes. You need to have Microsoft's Internet Explorer (Version 4.01 SP1 or higher) installed in order to use XMLwriter. Other XML-enabled browsers can be found at the XML Software site.

What benefits do I get from registering?
When you register XMLwriter 1.0 Beta you will:
- receive the next TWO versions of XMLwriter for FREE!
- receive priority in support response
- and if you wish, we will keep you up to date with the latest XMLwriter developments
I lost my registration number. How can I find out what it was?
Simple. Just fill out the registration help form. If you did not find the answer to your question here, please go to our support page and complete the appropriate form. We will keep adding to this page regularly.


Installation help topics

Installation contents page

  • Install XMLwriter
  • Remove XMLwriter


Welcome to XMLwriter's program help!
Welcome to XMLwriter 1.0 Beta program help!

Select the Contents tab to browse through the help topics by category.

Select the Index tab to search for a particular topic, or scroll through the list of topics in alphabetical order.

Select the Search tab to search for a word or phrase that may be contained in a help topic.

If you find a help topic you would like to bookmark, you can place it in the favorites list by selecting the Favorites tab and clicking the Add button.

Please keep an eye out at our website for the latest release of XMLwriter, or join the XMLwriter-news mailing list from our mailing lists page. If you register XMLwriter 1.0 Beta now, you will receive the next TWO UPGRADES FREE!


Wattle Software's privacy statement

We at Wattle Software respect our customers' privacy. Under no circumstances will your personal details or email address EVER be given or sold to a third party. The ONLY exception to this policy is if Wattle Software is ordered to provide such information by a court or officer of the law.


How to show/hide shortcut key assignments in tooltips

1 On the View menu, click Customise.
2 The Customise dialogue box is displayed.
3 Select the Toolbars tab.
4 Select the Show ToolTips check box.
5 Select the With Shortcut Keys check box.
5 Click Close on the Customise dialogue box to return to text editing mode.

Note: The Show ToolTips check box must be selected for the With Shortcut Keys option to be enabled.

Related Topics
How to show/hide tooltips on a toolbar
How to display text, an icon, or both on a toolbar button
How to assign a new shortcut key to a command